/* MonitorMode.c generated by valac 0.56.13, the Vala compiler
 * generated from MonitorMode.vala, do not modify */

/*-
 * Copyright (c) 2018 elementary LLC.
 *
 * This software is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this software; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301, USA.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include "display.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <glib-object.h>

enum  {
	DISPLAY_MONITOR_MODE_0_PROPERTY,
	DISPLAY_MONITOR_MODE_ID_PROPERTY,
	DISPLAY_MONITOR_MODE_WIDTH_PROPERTY,
	DISPLAY_MONITOR_MODE_HEIGHT_PROPERTY,
	DISPLAY_MONITOR_MODE_FREQUENCY_PROPERTY,
	DISPLAY_MONITOR_MODE_PREFERRED_SCALE_PROPERTY,
	DISPLAY_MONITOR_MODE_IS_PREFERRED_PROPERTY,
	DISPLAY_MONITOR_MODE_IS_CURRENT_PROPERTY,
	DISPLAY_MONITOR_MODE_NUM_PROPERTIES
};
static GParamSpec* display_monitor_mode_properties[DISPLAY_MONITOR_MODE_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))

struct _DisplayMonitorModePrivate {
	gchar* _id;
	gint _width;
	gint _height;
	gdouble _frequency;
	gdouble _preferred_scale;
	gboolean _is_preferred;
	gboolean _is_current;
	gchar* resolution_cache;
};

static gint DisplayMonitorMode_private_offset;
static gpointer display_monitor_mode_parent_class = NULL;

static gchar* display_monitor_mode_make_aspect_string (gint width,
                                                gint height);
static void display_monitor_mode_finalize (GObject * obj);
static GType display_monitor_mode_get_type_once (void);
static void _vala_display_monitor_mode_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec);
static void _vala_display_monitor_mode_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
display_monitor_mode_get_instance_private (DisplayMonitorMode* self)
{
	return G_STRUCT_MEMBER_P (self, DisplayMonitorMode_private_offset);
}

gint
display_monitor_mode_resolution_compare_func (DisplayMonitorMode* a,
                                              DisplayMonitorMode* b)
{
	gint _tmp0_;
	gint _tmp1_;
	gint result;
#line 23 "../src/Objects/MonitorMode.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 23 "../src/Objects/MonitorMode.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 24 "../src/Objects/MonitorMode.vala"
	_tmp0_ = a->priv->_width;
#line 24 "../src/Objects/MonitorMode.vala"
	_tmp1_ = b->priv->_width;
#line 24 "../src/Objects/MonitorMode.vala"
	if (_tmp0_ == _tmp1_) {
#line 100 "MonitorMode.c"
		gint _tmp2_;
		gint _tmp3_;
#line 25 "../src/Objects/MonitorMode.vala"
		_tmp2_ = a->priv->_height;
#line 25 "../src/Objects/MonitorMode.vala"
		_tmp3_ = b->priv->_height;
#line 25 "../src/Objects/MonitorMode.vala"
		if (_tmp2_ == _tmp3_) {
#line 26 "../src/Objects/MonitorMode.vala"
			result = 0;
#line 26 "../src/Objects/MonitorMode.vala"
			return result;
#line 113 "MonitorMode.c"
		} else {
			gint _tmp4_ = 0;
			gint _tmp5_;
			gint _tmp6_;
#line 28 "../src/Objects/MonitorMode.vala"
			_tmp5_ = a->priv->_height;
#line 28 "../src/Objects/MonitorMode.vala"
			_tmp6_ = b->priv->_height;
#line 28 "../src/Objects/MonitorMode.vala"
			if (_tmp5_ > _tmp6_) {
#line 28 "../src/Objects/MonitorMode.vala"
				_tmp4_ = -1;
#line 126 "MonitorMode.c"
			} else {
#line 28 "../src/Objects/MonitorMode.vala"
				_tmp4_ = 1;
#line 130 "MonitorMode.c"
			}
#line 28 "../src/Objects/MonitorMode.vala"
			result = _tmp4_;
#line 28 "../src/Objects/MonitorMode.vala"
			return result;
#line 136 "MonitorMode.c"
		}
	} else {
		gint _tmp7_ = 0;
		gint _tmp8_;
		gint _tmp9_;
#line 31 "../src/Objects/MonitorMode.vala"
		_tmp8_ = a->priv->_width;
#line 31 "../src/Objects/MonitorMode.vala"
		_tmp9_ = b->priv->_width;
#line 31 "../src/Objects/MonitorMode.vala"
		if (_tmp8_ > _tmp9_) {
#line 31 "../src/Objects/MonitorMode.vala"
			_tmp7_ = -1;
#line 150 "MonitorMode.c"
		} else {
#line 31 "../src/Objects/MonitorMode.vala"
			_tmp7_ = 1;
#line 154 "MonitorMode.c"
		}
#line 31 "../src/Objects/MonitorMode.vala"
		result = _tmp7_;
#line 31 "../src/Objects/MonitorMode.vala"
		return result;
#line 160 "MonitorMode.c"
	}
}

const gchar*
display_monitor_mode_get_resolution (DisplayMonitorMode* self)
{
	const gchar* _tmp0_;
	const gchar* _tmp4_;
	const gchar* result;
#line 46 "../src/Objects/MonitorMode.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 47 "../src/Objects/MonitorMode.vala"
	_tmp0_ = self->priv->resolution_cache;
#line 47 "../src/Objects/MonitorMode.vala"
	if (_tmp0_ == NULL) {
#line 176 "MonitorMode.c"
		gint _tmp1_;
		gint _tmp2_;
		gchar* _tmp3_;
#line 48 "../src/Objects/MonitorMode.vala"
		_tmp1_ = self->priv->_width;
#line 48 "../src/Objects/MonitorMode.vala"
		_tmp2_ = self->priv->_height;
#line 48 "../src/Objects/MonitorMode.vala"
		_tmp3_ = display_monitor_mode_get_resolution_string (_tmp1_, _tmp2_, TRUE);
#line 48 "../src/Objects/MonitorMode.vala"
		_g_free0 (self->priv->resolution_cache);
#line 48 "../src/Objects/MonitorMode.vala"
		self->priv->resolution_cache = _tmp3_;
#line 190 "MonitorMode.c"
	}
#line 51 "../src/Objects/MonitorMode.vala"
	_tmp4_ = self->priv->resolution_cache;
#line 51 "../src/Objects/MonitorMode.vala"
	result = _tmp4_;
#line 51 "../src/Objects/MonitorMode.vala"
	return result;
#line 198 "MonitorMode.c"
}

gchar*
display_monitor_mode_get_resolution_string (gint width,
                                            gint height,
                                            gboolean include_aspect)
{
	gchar* _tmp4_;
	gchar* result;
#line 55 "../src/Objects/MonitorMode.vala"
	if (include_aspect) {
#line 210 "MonitorMode.c"
		gchar* aspect = NULL;
		gchar* _tmp0_;
		const gchar* _tmp1_;
#line 56 "../src/Objects/MonitorMode.vala"
		_tmp0_ = display_monitor_mode_make_aspect_string (width, height);
#line 56 "../src/Objects/MonitorMode.vala"
		aspect = _tmp0_;
#line 57 "../src/Objects/MonitorMode.vala"
		_tmp1_ = aspect;
#line 57 "../src/Objects/MonitorMode.vala"
		if (_tmp1_ != NULL) {
#line 222 "MonitorMode.c"
			const gchar* _tmp2_;
			gchar* _tmp3_;
#line 58 "../src/Objects/MonitorMode.vala"
			_tmp2_ = aspect;
#line 58 "../src/Objects/MonitorMode.vala"
			_tmp3_ = g_strdup_printf ("%u × %u (%s)", (guint) width, (guint) height, _tmp2_);
#line 58 "../src/Objects/MonitorMode.vala"
			result = _tmp3_;
#line 58 "../src/Objects/MonitorMode.vala"
			_g_free0 (aspect);
#line 58 "../src/Objects/MonitorMode.vala"
			return result;
#line 235 "MonitorMode.c"
		}
#line 55 "../src/Objects/MonitorMode.vala"
		_g_free0 (aspect);
#line 239 "MonitorMode.c"
	}
#line 62 "../src/Objects/MonitorMode.vala"
	_tmp4_ = g_strdup_printf ("%u × %u", (guint) width, (guint) height);
#line 62 "../src/Objects/MonitorMode.vala"
	result = _tmp4_;
#line 62 "../src/Objects/MonitorMode.vala"
	return result;
#line 247 "MonitorMode.c"
}

static gchar*
display_monitor_mode_make_aspect_string (gint width,
                                         gint height)
{
	gint ratio = 0;
	gchar* aspect = NULL;
	gboolean _tmp0_ = FALSE;
	gchar* result;
#line 67 "../src/Objects/MonitorMode.vala"
	aspect = NULL;
#line 69 "../src/Objects/MonitorMode.vala"
	if (width == 0) {
#line 69 "../src/Objects/MonitorMode.vala"
		_tmp0_ = TRUE;
#line 264 "MonitorMode.c"
	} else {
#line 69 "../src/Objects/MonitorMode.vala"
		_tmp0_ = height == 0;
#line 268 "MonitorMode.c"
	}
#line 69 "../src/Objects/MonitorMode.vala"
	if (_tmp0_) {
#line 70 "../src/Objects/MonitorMode.vala"
		result = NULL;
#line 70 "../src/Objects/MonitorMode.vala"
		_g_free0 (aspect);
#line 70 "../src/Objects/MonitorMode.vala"
		return result;
#line 278 "MonitorMode.c"
	}
#line 72 "../src/Objects/MonitorMode.vala"
	if (width > height) {
#line 73 "../src/Objects/MonitorMode.vala"
		ratio = (width * 10) / height;
#line 284 "MonitorMode.c"
	} else {
#line 75 "../src/Objects/MonitorMode.vala"
		ratio = (height * 10) / width;
#line 288 "MonitorMode.c"
	}
#line 78 "../src/Objects/MonitorMode.vala"
	switch (ratio) {
#line 78 "../src/Objects/MonitorMode.vala"
		case 13:
#line 294 "MonitorMode.c"
		{
			gchar* _tmp1_;
#line 80 "../src/Objects/MonitorMode.vala"
			_tmp1_ = g_strdup ("4∶3");
#line 80 "../src/Objects/MonitorMode.vala"
			_g_free0 (aspect);
#line 80 "../src/Objects/MonitorMode.vala"
			aspect = _tmp1_;
#line 81 "../src/Objects/MonitorMode.vala"
			break;
#line 305 "MonitorMode.c"
		}
#line 78 "../src/Objects/MonitorMode.vala"
		case 16:
#line 309 "MonitorMode.c"
		{
			gchar* _tmp2_;
#line 83 "../src/Objects/MonitorMode.vala"
			_tmp2_ = g_strdup ("16∶10");
#line 83 "../src/Objects/MonitorMode.vala"
			_g_free0 (aspect);
#line 83 "../src/Objects/MonitorMode.vala"
			aspect = _tmp2_;
#line 84 "../src/Objects/MonitorMode.vala"
			break;
#line 320 "MonitorMode.c"
		}
#line 78 "../src/Objects/MonitorMode.vala"
		case 17:
#line 324 "MonitorMode.c"
		{
			gchar* _tmp3_;
#line 86 "../src/Objects/MonitorMode.vala"
			_tmp3_ = g_strdup ("16∶9");
#line 86 "../src/Objects/MonitorMode.vala"
			_g_free0 (aspect);
#line 86 "../src/Objects/MonitorMode.vala"
			aspect = _tmp3_;
#line 87 "../src/Objects/MonitorMode.vala"
			break;
#line 335 "MonitorMode.c"
		}
#line 78 "../src/Objects/MonitorMode.vala"
		case 23:
#line 339 "MonitorMode.c"
		{
			gchar* _tmp4_;
#line 89 "../src/Objects/MonitorMode.vala"
			_tmp4_ = g_strdup ("21∶9");
#line 89 "../src/Objects/MonitorMode.vala"
			_g_free0 (aspect);
#line 89 "../src/Objects/MonitorMode.vala"
			aspect = _tmp4_;
#line 90 "../src/Objects/MonitorMode.vala"
			break;
#line 350 "MonitorMode.c"
		}
#line 78 "../src/Objects/MonitorMode.vala"
		case 12:
#line 354 "MonitorMode.c"
		{
			gchar* _tmp5_;
#line 92 "../src/Objects/MonitorMode.vala"
			_tmp5_ = g_strdup ("5∶4");
#line 92 "../src/Objects/MonitorMode.vala"
			_g_free0 (aspect);
#line 92 "../src/Objects/MonitorMode.vala"
			aspect = _tmp5_;
#line 93 "../src/Objects/MonitorMode.vala"
			break;
#line 365 "MonitorMode.c"
		}
#line 78 "../src/Objects/MonitorMode.vala"
		case 15:
#line 369 "MonitorMode.c"
		{
			gchar* _tmp6_;
#line 96 "../src/Objects/MonitorMode.vala"
			_tmp6_ = g_strdup ("3∶2");
#line 96 "../src/Objects/MonitorMode.vala"
			_g_free0 (aspect);
#line 96 "../src/Objects/MonitorMode.vala"
			aspect = _tmp6_;
#line 97 "../src/Objects/MonitorMode.vala"
			break;
#line 380 "MonitorMode.c"
		}
#line 78 "../src/Objects/MonitorMode.vala"
		case 18:
#line 384 "MonitorMode.c"
		{
			gchar* _tmp7_;
#line 99 "../src/Objects/MonitorMode.vala"
			_tmp7_ = g_strdup ("9∶5");
#line 99 "../src/Objects/MonitorMode.vala"
			_g_free0 (aspect);
#line 99 "../src/Objects/MonitorMode.vala"
			aspect = _tmp7_;
#line 100 "../src/Objects/MonitorMode.vala"
			break;
#line 395 "MonitorMode.c"
		}
#line 78 "../src/Objects/MonitorMode.vala"
		case 10:
#line 399 "MonitorMode.c"
		{
			gchar* _tmp8_;
#line 102 "../src/Objects/MonitorMode.vala"
			_tmp8_ = g_strdup ("1∶1");
#line 102 "../src/Objects/MonitorMode.vala"
			_g_free0 (aspect);
#line 102 "../src/Objects/MonitorMode.vala"
			aspect = _tmp8_;
#line 103 "../src/Objects/MonitorMode.vala"
			break;
#line 410 "MonitorMode.c"
		}
		default:
#line 78 "../src/Objects/MonitorMode.vala"
		break;
#line 415 "MonitorMode.c"
	}
#line 106 "../src/Objects/MonitorMode.vala"
	result = aspect;
#line 106 "../src/Objects/MonitorMode.vala"
	return result;
#line 421 "MonitorMode.c"
}

DisplayMonitorMode*
display_monitor_mode_construct (GType object_type)
{
	DisplayMonitorMode * self = NULL;
#line 22 "../src/Objects/MonitorMode.vala"
	self = (DisplayMonitorMode*) g_object_new (object_type, NULL);
#line 22 "../src/Objects/MonitorMode.vala"
	return self;
#line 432 "MonitorMode.c"
}

DisplayMonitorMode*
display_monitor_mode_new (void)
{
#line 22 "../src/Objects/MonitorMode.vala"
	return display_monitor_mode_construct (DISPLAY_TYPE_MONITOR_MODE);
#line 440 "MonitorMode.c"
}

const gchar*
display_monitor_mode_get_id (DisplayMonitorMode* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 35 "../src/Objects/MonitorMode.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 35 "../src/Objects/MonitorMode.vala"
	_tmp0_ = self->priv->_id;
#line 35 "../src/Objects/MonitorMode.vala"
	result = _tmp0_;
#line 35 "../src/Objects/MonitorMode.vala"
	return result;
#line 456 "MonitorMode.c"
}

void
display_monitor_mode_set_id (DisplayMonitorMode* self,
                             const gchar* value)
{
	gchar* old_value;
#line 35 "../src/Objects/MonitorMode.vala"
	g_return_if_fail (self != NULL);
#line 35 "../src/Objects/MonitorMode.vala"
	old_value = display_monitor_mode_get_id (self);
#line 35 "../src/Objects/MonitorMode.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 470 "MonitorMode.c"
		gchar* _tmp0_;
#line 35 "../src/Objects/MonitorMode.vala"
		_tmp0_ = g_strdup (value);
#line 35 "../src/Objects/MonitorMode.vala"
		_g_free0 (self->priv->_id);
#line 35 "../src/Objects/MonitorMode.vala"
		self->priv->_id = _tmp0_;
#line 35 "../src/Objects/MonitorMode.vala"
		g_object_notify_by_pspec ((GObject *) self, display_monitor_mode_properties[DISPLAY_MONITOR_MODE_ID_PROPERTY]);
#line 480 "MonitorMode.c"
	}
}

gint
display_monitor_mode_get_width (DisplayMonitorMode* self)
{
	gint result;
#line 36 "../src/Objects/MonitorMode.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 36 "../src/Objects/MonitorMode.vala"
	result = self->priv->_width;
#line 36 "../src/Objects/MonitorMode.vala"
	return result;
#line 494 "MonitorMode.c"
}

void
display_monitor_mode_set_width (DisplayMonitorMode* self,
                                gint value)
{
	gint old_value;
#line 36 "../src/Objects/MonitorMode.vala"
	g_return_if_fail (self != NULL);
#line 36 "../src/Objects/MonitorMode.vala"
	old_value = display_monitor_mode_get_width (self);
#line 36 "../src/Objects/MonitorMode.vala"
	if (old_value != value) {
#line 36 "../src/Objects/MonitorMode.vala"
		self->priv->_width = value;
#line 36 "../src/Objects/MonitorMode.vala"
		g_object_notify_by_pspec ((GObject *) self, display_monitor_mode_properties[DISPLAY_MONITOR_MODE_WIDTH_PROPERTY]);
#line 512 "MonitorMode.c"
	}
}

gint
display_monitor_mode_get_height (DisplayMonitorMode* self)
{
	gint result;
#line 37 "../src/Objects/MonitorMode.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 37 "../src/Objects/MonitorMode.vala"
	result = self->priv->_height;
#line 37 "../src/Objects/MonitorMode.vala"
	return result;
#line 526 "MonitorMode.c"
}

void
display_monitor_mode_set_height (DisplayMonitorMode* self,
                                 gint value)
{
	gint old_value;
#line 37 "../src/Objects/MonitorMode.vala"
	g_return_if_fail (self != NULL);
#line 37 "../src/Objects/MonitorMode.vala"
	old_value = display_monitor_mode_get_height (self);
#line 37 "../src/Objects/MonitorMode.vala"
	if (old_value != value) {
#line 37 "../src/Objects/MonitorMode.vala"
		self->priv->_height = value;
#line 37 "../src/Objects/MonitorMode.vala"
		g_object_notify_by_pspec ((GObject *) self, display_monitor_mode_properties[DISPLAY_MONITOR_MODE_HEIGHT_PROPERTY]);
#line 544 "MonitorMode.c"
	}
}

gdouble
display_monitor_mode_get_frequency (DisplayMonitorMode* self)
{
	gdouble result;
#line 38 "../src/Objects/MonitorMode.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 38 "../src/Objects/MonitorMode.vala"
	result = self->priv->_frequency;
#line 38 "../src/Objects/MonitorMode.vala"
	return result;
#line 558 "MonitorMode.c"
}

void
display_monitor_mode_set_frequency (DisplayMonitorMode* self,
                                    gdouble value)
{
	gdouble old_value;
#line 38 "../src/Objects/MonitorMode.vala"
	g_return_if_fail (self != NULL);
#line 38 "../src/Objects/MonitorMode.vala"
	old_value = display_monitor_mode_get_frequency (self);
#line 38 "../src/Objects/MonitorMode.vala"
	if (old_value != value) {
#line 38 "../src/Objects/MonitorMode.vala"
		self->priv->_frequency = value;
#line 38 "../src/Objects/MonitorMode.vala"
		g_object_notify_by_pspec ((GObject *) self, display_monitor_mode_properties[DISPLAY_MONITOR_MODE_FREQUENCY_PROPERTY]);
#line 576 "MonitorMode.c"
	}
}

gdouble
display_monitor_mode_get_preferred_scale (DisplayMonitorMode* self)
{
	gdouble result;
#line 39 "../src/Objects/MonitorMode.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 39 "../src/Objects/MonitorMode.vala"
	result = self->priv->_preferred_scale;
#line 39 "../src/Objects/MonitorMode.vala"
	return result;
#line 590 "MonitorMode.c"
}

void
display_monitor_mode_set_preferred_scale (DisplayMonitorMode* self,
                                          gdouble value)
{
	gdouble old_value;
#line 39 "../src/Objects/MonitorMode.vala"
	g_return_if_fail (self != NULL);
#line 39 "../src/Objects/MonitorMode.vala"
	old_value = display_monitor_mode_get_preferred_scale (self);
#line 39 "../src/Objects/MonitorMode.vala"
	if (old_value != value) {
#line 39 "../src/Objects/MonitorMode.vala"
		self->priv->_preferred_scale = value;
#line 39 "../src/Objects/MonitorMode.vala"
		g_object_notify_by_pspec ((GObject *) self, display_monitor_mode_properties[DISPLAY_MONITOR_MODE_PREFERRED_SCALE_PROPERTY]);
#line 608 "MonitorMode.c"
	}
}

gboolean
display_monitor_mode_get_is_preferred (DisplayMonitorMode* self)
{
	gboolean result;
#line 40 "../src/Objects/MonitorMode.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 40 "../src/Objects/MonitorMode.vala"
	result = self->priv->_is_preferred;
#line 40 "../src/Objects/MonitorMode.vala"
	return result;
#line 622 "MonitorMode.c"
}

void
display_monitor_mode_set_is_preferred (DisplayMonitorMode* self,
                                       gboolean value)
{
	gboolean old_value;
#line 40 "../src/Objects/MonitorMode.vala"
	g_return_if_fail (self != NULL);
#line 40 "../src/Objects/MonitorMode.vala"
	old_value = display_monitor_mode_get_is_preferred (self);
#line 40 "../src/Objects/MonitorMode.vala"
	if (old_value != value) {
#line 40 "../src/Objects/MonitorMode.vala"
		self->priv->_is_preferred = value;
#line 40 "../src/Objects/MonitorMode.vala"
		g_object_notify_by_pspec ((GObject *) self, display_monitor_mode_properties[DISPLAY_MONITOR_MODE_IS_PREFERRED_PROPERTY]);
#line 640 "MonitorMode.c"
	}
}

gboolean
display_monitor_mode_get_is_current (DisplayMonitorMode* self)
{
	gboolean result;
#line 41 "../src/Objects/MonitorMode.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 41 "../src/Objects/MonitorMode.vala"
	result = self->priv->_is_current;
#line 41 "../src/Objects/MonitorMode.vala"
	return result;
#line 654 "MonitorMode.c"
}

void
display_monitor_mode_set_is_current (DisplayMonitorMode* self,
                                     gboolean value)
{
	gboolean old_value;
#line 41 "../src/Objects/MonitorMode.vala"
	g_return_if_fail (self != NULL);
#line 41 "../src/Objects/MonitorMode.vala"
	old_value = display_monitor_mode_get_is_current (self);
#line 41 "../src/Objects/MonitorMode.vala"
	if (old_value != value) {
#line 41 "../src/Objects/MonitorMode.vala"
		self->priv->_is_current = value;
#line 41 "../src/Objects/MonitorMode.vala"
		g_object_notify_by_pspec ((GObject *) self, display_monitor_mode_properties[DISPLAY_MONITOR_MODE_IS_CURRENT_PROPERTY]);
#line 672 "MonitorMode.c"
	}
}

static void
display_monitor_mode_class_init (DisplayMonitorModeClass * klass,
                                 gpointer klass_data)
{
#line 22 "../src/Objects/MonitorMode.vala"
	display_monitor_mode_parent_class = g_type_class_peek_parent (klass);
#line 22 "../src/Objects/MonitorMode.vala"
	g_type_class_adjust_private_offset (klass, &DisplayMonitorMode_private_offset);
#line 22 "../src/Objects/MonitorMode.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_display_monitor_mode_get_property;
#line 22 "../src/Objects/MonitorMode.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_display_monitor_mode_set_property;
#line 22 "../src/Objects/MonitorMode.vala"
	G_OBJECT_CLASS (klass)->finalize = display_monitor_mode_finalize;
#line 22 "../src/Objects/MonitorMode.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_MONITOR_MODE_ID_PROPERTY, display_monitor_mode_properties[DISPLAY_MONITOR_MODE_ID_PROPERTY] = g_param_spec_string ("id", "id", "id", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../src/Objects/MonitorMode.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_MONITOR_MODE_WIDTH_PROPERTY, display_monitor_mode_properties[DISPLAY_MONITOR_MODE_WIDTH_PROPERTY] = g_param_spec_int ("width", "width", "width", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../src/Objects/MonitorMode.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_MONITOR_MODE_HEIGHT_PROPERTY, display_monitor_mode_properties[DISPLAY_MONITOR_MODE_HEIGHT_PROPERTY] = g_param_spec_int ("height", "height", "height", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../src/Objects/MonitorMode.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_MONITOR_MODE_FREQUENCY_PROPERTY, display_monitor_mode_properties[DISPLAY_MONITOR_MODE_FREQUENCY_PROPERTY] = g_param_spec_double ("frequency", "frequency", "frequency", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../src/Objects/MonitorMode.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_MONITOR_MODE_PREFERRED_SCALE_PROPERTY, display_monitor_mode_properties[DISPLAY_MONITOR_MODE_PREFERRED_SCALE_PROPERTY] = g_param_spec_double ("preferred-scale", "preferred-scale", "preferred-scale", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../src/Objects/MonitorMode.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_MONITOR_MODE_IS_PREFERRED_PROPERTY, display_monitor_mode_properties[DISPLAY_MONITOR_MODE_IS_PREFERRED_PROPERTY] = g_param_spec_boolean ("is-preferred", "is-preferred", "is-preferred", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../src/Objects/MonitorMode.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_MONITOR_MODE_IS_CURRENT_PROPERTY, display_monitor_mode_properties[DISPLAY_MONITOR_MODE_IS_CURRENT_PROPERTY] = g_param_spec_boolean ("is-current", "is-current", "is-current", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 704 "MonitorMode.c"
}

static void
display_monitor_mode_instance_init (DisplayMonitorMode * self,
                                    gpointer klass)
{
#line 22 "../src/Objects/MonitorMode.vala"
	self->priv = display_monitor_mode_get_instance_private (self);
#line 45 "../src/Objects/MonitorMode.vala"
	self->priv->resolution_cache = NULL;
#line 715 "MonitorMode.c"
}

static void
display_monitor_mode_finalize (GObject * obj)
{
	DisplayMonitorMode * self;
#line 22 "../src/Objects/MonitorMode.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DISPLAY_TYPE_MONITOR_MODE, DisplayMonitorMode);
#line 35 "../src/Objects/MonitorMode.vala"
	_g_free0 (self->priv->_id);
#line 43 "../src/Objects/MonitorMode.vala"
	self->supported_scales = (g_free (self->supported_scales), NULL);
#line 45 "../src/Objects/MonitorMode.vala"
	_g_free0 (self->priv->resolution_cache);
#line 22 "../src/Objects/MonitorMode.vala"
	G_OBJECT_CLASS (display_monitor_mode_parent_class)->finalize (obj);
#line 732 "MonitorMode.c"
}

static GType
display_monitor_mode_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DisplayMonitorModeClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) display_monitor_mode_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DisplayMonitorMode), 0, (GInstanceInitFunc) display_monitor_mode_instance_init, NULL };
	GType display_monitor_mode_type_id;
	display_monitor_mode_type_id = g_type_register_static (G_TYPE_OBJECT, "DisplayMonitorMode", &g_define_type_info, 0);
	DisplayMonitorMode_private_offset = g_type_add_instance_private (display_monitor_mode_type_id, sizeof (DisplayMonitorModePrivate));
	return display_monitor_mode_type_id;
}

GType
display_monitor_mode_get_type (void)
{
	static volatile gsize display_monitor_mode_type_id__once = 0;
	if (g_once_init_enter (&display_monitor_mode_type_id__once)) {
		GType display_monitor_mode_type_id;
		display_monitor_mode_type_id = display_monitor_mode_get_type_once ();
		g_once_init_leave (&display_monitor_mode_type_id__once, display_monitor_mode_type_id);
	}
	return display_monitor_mode_type_id__once;
}

static void
_vala_display_monitor_mode_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec)
{
	DisplayMonitorMode * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DISPLAY_TYPE_MONITOR_MODE, DisplayMonitorMode);
#line 22 "../src/Objects/MonitorMode.vala"
	switch (property_id) {
#line 22 "../src/Objects/MonitorMode.vala"
		case DISPLAY_MONITOR_MODE_ID_PROPERTY:
#line 22 "../src/Objects/MonitorMode.vala"
		g_value_set_string (value, display_monitor_mode_get_id (self));
#line 22 "../src/Objects/MonitorMode.vala"
		break;
#line 22 "../src/Objects/MonitorMode.vala"
		case DISPLAY_MONITOR_MODE_WIDTH_PROPERTY:
#line 22 "../src/Objects/MonitorMode.vala"
		g_value_set_int (value, display_monitor_mode_get_width (self));
#line 22 "../src/Objects/MonitorMode.vala"
		break;
#line 22 "../src/Objects/MonitorMode.vala"
		case DISPLAY_MONITOR_MODE_HEIGHT_PROPERTY:
#line 22 "../src/Objects/MonitorMode.vala"
		g_value_set_int (value, display_monitor_mode_get_height (self));
#line 22 "../src/Objects/MonitorMode.vala"
		break;
#line 22 "../src/Objects/MonitorMode.vala"
		case DISPLAY_MONITOR_MODE_FREQUENCY_PROPERTY:
#line 22 "../src/Objects/MonitorMode.vala"
		g_value_set_double (value, display_monitor_mode_get_frequency (self));
#line 22 "../src/Objects/MonitorMode.vala"
		break;
#line 22 "../src/Objects/MonitorMode.vala"
		case DISPLAY_MONITOR_MODE_PREFERRED_SCALE_PROPERTY:
#line 22 "../src/Objects/MonitorMode.vala"
		g_value_set_double (value, display_monitor_mode_get_preferred_scale (self));
#line 22 "../src/Objects/MonitorMode.vala"
		break;
#line 22 "../src/Objects/MonitorMode.vala"
		case DISPLAY_MONITOR_MODE_IS_PREFERRED_PROPERTY:
#line 22 "../src/Objects/MonitorMode.vala"
		g_value_set_boolean (value, display_monitor_mode_get_is_preferred (self));
#line 22 "../src/Objects/MonitorMode.vala"
		break;
#line 22 "../src/Objects/MonitorMode.vala"
		case DISPLAY_MONITOR_MODE_IS_CURRENT_PROPERTY:
#line 22 "../src/Objects/MonitorMode.vala"
		g_value_set_boolean (value, display_monitor_mode_get_is_current (self));
#line 22 "../src/Objects/MonitorMode.vala"
		break;
#line 809 "MonitorMode.c"
		default:
#line 22 "../src/Objects/MonitorMode.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/Objects/MonitorMode.vala"
		break;
#line 815 "MonitorMode.c"
	}
}

static void
_vala_display_monitor_mode_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec)
{
	DisplayMonitorMode * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DISPLAY_TYPE_MONITOR_MODE, DisplayMonitorMode);
#line 22 "../src/Objects/MonitorMode.vala"
	switch (property_id) {
#line 22 "../src/Objects/MonitorMode.vala"
		case DISPLAY_MONITOR_MODE_ID_PROPERTY:
#line 22 "../src/Objects/MonitorMode.vala"
		display_monitor_mode_set_id (self, g_value_get_string (value));
#line 22 "../src/Objects/MonitorMode.vala"
		break;
#line 22 "../src/Objects/MonitorMode.vala"
		case DISPLAY_MONITOR_MODE_WIDTH_PROPERTY:
#line 22 "../src/Objects/MonitorMode.vala"
		display_monitor_mode_set_width (self, g_value_get_int (value));
#line 22 "../src/Objects/MonitorMode.vala"
		break;
#line 22 "../src/Objects/MonitorMode.vala"
		case DISPLAY_MONITOR_MODE_HEIGHT_PROPERTY:
#line 22 "../src/Objects/MonitorMode.vala"
		display_monitor_mode_set_height (self, g_value_get_int (value));
#line 22 "../src/Objects/MonitorMode.vala"
		break;
#line 22 "../src/Objects/MonitorMode.vala"
		case DISPLAY_MONITOR_MODE_FREQUENCY_PROPERTY:
#line 22 "../src/Objects/MonitorMode.vala"
		display_monitor_mode_set_frequency (self, g_value_get_double (value));
#line 22 "../src/Objects/MonitorMode.vala"
		break;
#line 22 "../src/Objects/MonitorMode.vala"
		case DISPLAY_MONITOR_MODE_PREFERRED_SCALE_PROPERTY:
#line 22 "../src/Objects/MonitorMode.vala"
		display_monitor_mode_set_preferred_scale (self, g_value_get_double (value));
#line 22 "../src/Objects/MonitorMode.vala"
		break;
#line 22 "../src/Objects/MonitorMode.vala"
		case DISPLAY_MONITOR_MODE_IS_PREFERRED_PROPERTY:
#line 22 "../src/Objects/MonitorMode.vala"
		display_monitor_mode_set_is_preferred (self, g_value_get_boolean (value));
#line 22 "../src/Objects/MonitorMode.vala"
		break;
#line 22 "../src/Objects/MonitorMode.vala"
		case DISPLAY_MONITOR_MODE_IS_CURRENT_PROPERTY:
#line 22 "../src/Objects/MonitorMode.vala"
		display_monitor_mode_set_is_current (self, g_value_get_boolean (value));
#line 22 "../src/Objects/MonitorMode.vala"
		break;
#line 871 "MonitorMode.c"
		default:
#line 22 "../src/Objects/MonitorMode.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/Objects/MonitorMode.vala"
		break;
#line 877 "MonitorMode.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

