/* VirtualMonitor.c generated by valac 0.56.13, the Vala compiler
 * generated from VirtualMonitor.vala, do not modify */

/*-
 * Copyright (c) 2018 elementary LLC.
 *
 * This software is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this software; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301, USA.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include "display.h"
#include <glib.h>
#include <float.h>
#include <math.h>
#include <gee.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>

enum  {
	DISPLAY_VIRTUAL_MONITOR_0_PROPERTY,
	DISPLAY_VIRTUAL_MONITOR_X_PROPERTY,
	DISPLAY_VIRTUAL_MONITOR_Y_PROPERTY,
	DISPLAY_VIRTUAL_MONITOR_CURRENT_X_PROPERTY,
	DISPLAY_VIRTUAL_MONITOR_CURRENT_Y_PROPERTY,
	DISPLAY_VIRTUAL_MONITOR_SCALE_PROPERTY,
	DISPLAY_VIRTUAL_MONITOR_TRANSFORM_PROPERTY,
	DISPLAY_VIRTUAL_MONITOR_PRIMARY_PROPERTY,
	DISPLAY_VIRTUAL_MONITOR_MONITORS_PROPERTY,
	DISPLAY_VIRTUAL_MONITOR_ID_PROPERTY,
	DISPLAY_VIRTUAL_MONITOR_IS_MIRROR_PROPERTY,
	DISPLAY_VIRTUAL_MONITOR_IS_ACTIVE_PROPERTY,
	DISPLAY_VIRTUAL_MONITOR_MONITOR_PROPERTY,
	DISPLAY_VIRTUAL_MONITOR_NUM_PROPERTIES
};
static GParamSpec* display_virtual_monitor_properties[DISPLAY_VIRTUAL_MONITOR_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block1Data Block1Data;
enum  {
	DISPLAY_VIRTUAL_MONITOR_MODES_CHANGED_SIGNAL,
	DISPLAY_VIRTUAL_MONITOR_NUM_SIGNALS
};
static guint display_virtual_monitor_signals[DISPLAY_VIRTUAL_MONITOR_NUM_SIGNALS] = {0};

struct _DisplayVirtualMonitorPrivate {
	gint _x;
	gint _y;
	gint _current_x;
	gint _current_y;
	gdouble _scale;
	DisplayTransform _transform;
	gboolean _primary;
	GeeLinkedList* _monitors;
	gboolean _is_active;
};

struct _Block1Data {
	int _ref_count_;
	DisplayVirtualMonitor* self;
	DisplayMonitorMode* current_mode;
};

static gint DisplayVirtualMonitor_private_offset;
static gpointer display_virtual_monitor_parent_class = NULL;

static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static gboolean ___lambda4_ (Block1Data* _data1_,
                      DisplayMonitor* _monitor);
static gboolean ____lambda4__gee_forall_func (gpointer g,
                                       gpointer self);
static GObject * display_virtual_monitor_constructor (GType type,
                                               guint n_construct_properties,
                                               GObjectConstructParam * construct_properties);
static void display_virtual_monitor_finalize (GObject * obj);
static GType display_virtual_monitor_get_type_once (void);
static void _vala_display_virtual_monitor_get_property (GObject * object,
                                                 guint property_id,
                                                 GValue * value,
                                                 GParamSpec * pspec);
static void _vala_display_virtual_monitor_set_property (GObject * object,
                                                 guint property_id,
                                                 const GValue * value,
                                                 GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
display_virtual_monitor_get_instance_private (DisplayVirtualMonitor* self)
{
	return G_STRUCT_MEMBER_P (self, DisplayVirtualMonitor_private_offset);
}

const gchar*
display_virtual_monitor_get_display_name (DisplayVirtualMonitor* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	const gchar* result;
#line 75 "../src/Objects/VirtualMonitor.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 76 "../src/Objects/VirtualMonitor.vala"
	_tmp0_ = display_virtual_monitor_get_is_mirror (self);
#line 76 "../src/Objects/VirtualMonitor.vala"
	_tmp1_ = _tmp0_;
#line 76 "../src/Objects/VirtualMonitor.vala"
	if (_tmp1_) {
#line 77 "../src/Objects/VirtualMonitor.vala"
		result = _ ("Mirrored Display");
#line 77 "../src/Objects/VirtualMonitor.vala"
		return result;
#line 128 "VirtualMonitor.c"
	} else {
		DisplayMonitor* _tmp2_;
		DisplayMonitor* _tmp3_;
		DisplayMonitor* _tmp4_;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
#line 79 "../src/Objects/VirtualMonitor.vala"
		_tmp2_ = display_virtual_monitor_get_monitor (self);
#line 79 "../src/Objects/VirtualMonitor.vala"
		_tmp3_ = _tmp2_;
#line 79 "../src/Objects/VirtualMonitor.vala"
		_tmp4_ = _tmp3_;
#line 79 "../src/Objects/VirtualMonitor.vala"
		_tmp5_ = display_monitor_get_display_name (_tmp4_);
#line 79 "../src/Objects/VirtualMonitor.vala"
		_tmp6_ = _tmp5_;
#line 79 "../src/Objects/VirtualMonitor.vala"
		_tmp7_ = _tmp6_;
#line 79 "../src/Objects/VirtualMonitor.vala"
		_g_object_unref0 (_tmp4_);
#line 79 "../src/Objects/VirtualMonitor.vala"
		result = _tmp7_;
#line 79 "../src/Objects/VirtualMonitor.vala"
		return result;
#line 154 "VirtualMonitor.c"
	}
}

void
display_virtual_monitor_get_current_mode_size (DisplayVirtualMonitor* self,
                                               gint* width,
                                               gint* height)
{
	gint _vala_width = 0;
	gint _vala_height = 0;
	gboolean _tmp0_;
#line 83 "../src/Objects/VirtualMonitor.vala"
	g_return_if_fail (self != NULL);
#line 84 "../src/Objects/VirtualMonitor.vala"
	_tmp0_ = self->priv->_is_active;
#line 84 "../src/Objects/VirtualMonitor.vala"
	if (!_tmp0_) {
#line 172 "VirtualMonitor.c"
		{
			GeeLinkedList* _mode_list = NULL;
			DisplayMonitor* _tmp1_;
			DisplayMonitor* _tmp2_;
			DisplayMonitor* _tmp3_;
			GeeLinkedList* _tmp4_;
			GeeLinkedList* _tmp5_;
			GeeLinkedList* _tmp6_;
			gint _mode_size = 0;
			GeeLinkedList* _tmp7_;
			gint _tmp8_;
			gint _tmp9_;
			gint _mode_index = 0;
#line 87 "../src/Objects/VirtualMonitor.vala"
			_tmp1_ = display_virtual_monitor_get_monitor (self);
#line 87 "../src/Objects/VirtualMonitor.vala"
			_tmp2_ = _tmp1_;
#line 87 "../src/Objects/VirtualMonitor.vala"
			_tmp3_ = _tmp2_;
#line 87 "../src/Objects/VirtualMonitor.vala"
			_tmp4_ = display_monitor_get_modes (_tmp3_);
#line 87 "../src/Objects/VirtualMonitor.vala"
			_tmp5_ = _tmp4_;
#line 87 "../src/Objects/VirtualMonitor.vala"
			_tmp6_ = _tmp5_;
#line 87 "../src/Objects/VirtualMonitor.vala"
			_g_object_unref0 (_tmp3_);
#line 87 "../src/Objects/VirtualMonitor.vala"
			_mode_list = _tmp6_;
#line 87 "../src/Objects/VirtualMonitor.vala"
			_tmp7_ = _mode_list;
#line 87 "../src/Objects/VirtualMonitor.vala"
			_tmp8_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp7_);
#line 87 "../src/Objects/VirtualMonitor.vala"
			_tmp9_ = _tmp8_;
#line 87 "../src/Objects/VirtualMonitor.vala"
			_mode_size = _tmp9_;
#line 87 "../src/Objects/VirtualMonitor.vala"
			_mode_index = -1;
#line 87 "../src/Objects/VirtualMonitor.vala"
			while (TRUE) {
#line 214 "VirtualMonitor.c"
				gint _tmp10_;
				gint _tmp11_;
				DisplayMonitorMode* mode = NULL;
				GeeLinkedList* _tmp12_;
				gpointer _tmp13_;
				DisplayMonitorMode* _tmp14_;
				gboolean _tmp15_;
				gboolean _tmp16_;
#line 87 "../src/Objects/VirtualMonitor.vala"
				_mode_index = _mode_index + 1;
#line 87 "../src/Objects/VirtualMonitor.vala"
				_tmp10_ = _mode_index;
#line 87 "../src/Objects/VirtualMonitor.vala"
				_tmp11_ = _mode_size;
#line 87 "../src/Objects/VirtualMonitor.vala"
				if (!(_tmp10_ < _tmp11_)) {
#line 87 "../src/Objects/VirtualMonitor.vala"
					break;
#line 233 "VirtualMonitor.c"
				}
#line 87 "../src/Objects/VirtualMonitor.vala"
				_tmp12_ = _mode_list;
#line 87 "../src/Objects/VirtualMonitor.vala"
				_tmp13_ = gee_abstract_list_get ((GeeAbstractList*) _tmp12_, _mode_index);
#line 87 "../src/Objects/VirtualMonitor.vala"
				mode = (DisplayMonitorMode*) _tmp13_;
#line 88 "../src/Objects/VirtualMonitor.vala"
				_tmp14_ = mode;
#line 88 "../src/Objects/VirtualMonitor.vala"
				_tmp15_ = display_monitor_mode_get_is_preferred (_tmp14_);
#line 88 "../src/Objects/VirtualMonitor.vala"
				_tmp16_ = _tmp15_;
#line 88 "../src/Objects/VirtualMonitor.vala"
				if (_tmp16_) {
#line 249 "VirtualMonitor.c"
					DisplayMonitorMode* _tmp17_;
					gint _tmp18_;
					gint _tmp19_;
					DisplayMonitorMode* _tmp20_;
					gint _tmp21_;
					gint _tmp22_;
#line 89 "../src/Objects/VirtualMonitor.vala"
					_tmp17_ = mode;
#line 89 "../src/Objects/VirtualMonitor.vala"
					_tmp18_ = display_monitor_mode_get_width (_tmp17_);
#line 89 "../src/Objects/VirtualMonitor.vala"
					_tmp19_ = _tmp18_;
#line 89 "../src/Objects/VirtualMonitor.vala"
					_vala_width = _tmp19_;
#line 90 "../src/Objects/VirtualMonitor.vala"
					_tmp20_ = mode;
#line 90 "../src/Objects/VirtualMonitor.vala"
					_tmp21_ = display_monitor_mode_get_height (_tmp20_);
#line 90 "../src/Objects/VirtualMonitor.vala"
					_tmp22_ = _tmp21_;
#line 90 "../src/Objects/VirtualMonitor.vala"
					_vala_height = _tmp22_;
#line 91 "../src/Objects/VirtualMonitor.vala"
					_g_object_unref0 (mode);
#line 91 "../src/Objects/VirtualMonitor.vala"
					if (width) {
#line 91 "../src/Objects/VirtualMonitor.vala"
						*width = _vala_width;
#line 278 "VirtualMonitor.c"
					}
#line 91 "../src/Objects/VirtualMonitor.vala"
					if (height) {
#line 91 "../src/Objects/VirtualMonitor.vala"
						*height = _vala_height;
#line 284 "VirtualMonitor.c"
					}
#line 91 "../src/Objects/VirtualMonitor.vala"
					return;
#line 288 "VirtualMonitor.c"
				}
#line 87 "../src/Objects/VirtualMonitor.vala"
				_g_object_unref0 (mode);
#line 292 "VirtualMonitor.c"
			}
		}
#line 96 "../src/Objects/VirtualMonitor.vala"
		_vala_width = 1280;
#line 97 "../src/Objects/VirtualMonitor.vala"
		_vala_height = 720;
#line 299 "VirtualMonitor.c"
	} else {
		gboolean _tmp23_;
		gboolean _tmp24_;
#line 98 "../src/Objects/VirtualMonitor.vala"
		_tmp23_ = display_virtual_monitor_get_is_mirror (self);
#line 98 "../src/Objects/VirtualMonitor.vala"
		_tmp24_ = _tmp23_;
#line 98 "../src/Objects/VirtualMonitor.vala"
		if (_tmp24_) {
#line 309 "VirtualMonitor.c"
			DisplayMonitorMode* current_mode = NULL;
			GeeLinkedList* _tmp25_;
			gpointer _tmp26_;
			DisplayMonitor* _tmp27_;
			DisplayMonitorMode* _tmp28_;
			DisplayMonitorMode* _tmp29_;
			DisplayMonitorMode* _tmp30_;
			DisplayMonitorMode* _tmp31_;
			gint _tmp32_;
			gint _tmp33_;
			DisplayMonitorMode* _tmp34_;
			gint _tmp35_;
			gint _tmp36_;
#line 99 "../src/Objects/VirtualMonitor.vala"
			_tmp25_ = self->priv->_monitors;
#line 99 "../src/Objects/VirtualMonitor.vala"
			_tmp26_ = gee_abstract_list_get ((GeeAbstractList*) _tmp25_, 0);
#line 99 "../src/Objects/VirtualMonitor.vala"
			_tmp27_ = (DisplayMonitor*) _tmp26_;
#line 99 "../src/Objects/VirtualMonitor.vala"
			_tmp28_ = display_monitor_get_current_mode (_tmp27_);
#line 99 "../src/Objects/VirtualMonitor.vala"
			_tmp29_ = _tmp28_;
#line 99 "../src/Objects/VirtualMonitor.vala"
			_tmp30_ = _tmp29_;
#line 99 "../src/Objects/VirtualMonitor.vala"
			_g_object_unref0 (_tmp27_);
#line 99 "../src/Objects/VirtualMonitor.vala"
			current_mode = _tmp30_;
#line 100 "../src/Objects/VirtualMonitor.vala"
			_tmp31_ = current_mode;
#line 100 "../src/Objects/VirtualMonitor.vala"
			_tmp32_ = display_monitor_mode_get_width (_tmp31_);
#line 100 "../src/Objects/VirtualMonitor.vala"
			_tmp33_ = _tmp32_;
#line 100 "../src/Objects/VirtualMonitor.vala"
			_vala_width = _tmp33_;
#line 101 "../src/Objects/VirtualMonitor.vala"
			_tmp34_ = current_mode;
#line 101 "../src/Objects/VirtualMonitor.vala"
			_tmp35_ = display_monitor_mode_get_height (_tmp34_);
#line 101 "../src/Objects/VirtualMonitor.vala"
			_tmp36_ = _tmp35_;
#line 101 "../src/Objects/VirtualMonitor.vala"
			_vala_height = _tmp36_;
#line 98 "../src/Objects/VirtualMonitor.vala"
			_g_object_unref0 (current_mode);
#line 357 "VirtualMonitor.c"
		} else {
			DisplayMonitorMode* current_mode = NULL;
			DisplayMonitor* _tmp37_;
			DisplayMonitor* _tmp38_;
			DisplayMonitor* _tmp39_;
			DisplayMonitorMode* _tmp40_;
			DisplayMonitorMode* _tmp41_;
			DisplayMonitorMode* _tmp42_;
			DisplayMonitorMode* _tmp43_;
			gint _tmp44_;
			gint _tmp45_;
			DisplayMonitorMode* _tmp46_;
			gint _tmp47_;
			gint _tmp48_;
#line 103 "../src/Objects/VirtualMonitor.vala"
			_tmp37_ = display_virtual_monitor_get_monitor (self);
#line 103 "../src/Objects/VirtualMonitor.vala"
			_tmp38_ = _tmp37_;
#line 103 "../src/Objects/VirtualMonitor.vala"
			_tmp39_ = _tmp38_;
#line 103 "../src/Objects/VirtualMonitor.vala"
			_tmp40_ = display_monitor_get_current_mode (_tmp39_);
#line 103 "../src/Objects/VirtualMonitor.vala"
			_tmp41_ = _tmp40_;
#line 103 "../src/Objects/VirtualMonitor.vala"
			_tmp42_ = _tmp41_;
#line 103 "../src/Objects/VirtualMonitor.vala"
			_g_object_unref0 (_tmp39_);
#line 103 "../src/Objects/VirtualMonitor.vala"
			current_mode = _tmp42_;
#line 104 "../src/Objects/VirtualMonitor.vala"
			_tmp43_ = current_mode;
#line 104 "../src/Objects/VirtualMonitor.vala"
			_tmp44_ = display_monitor_mode_get_width (_tmp43_);
#line 104 "../src/Objects/VirtualMonitor.vala"
			_tmp45_ = _tmp44_;
#line 104 "../src/Objects/VirtualMonitor.vala"
			_vala_width = _tmp45_;
#line 105 "../src/Objects/VirtualMonitor.vala"
			_tmp46_ = current_mode;
#line 105 "../src/Objects/VirtualMonitor.vala"
			_tmp47_ = display_monitor_mode_get_height (_tmp46_);
#line 105 "../src/Objects/VirtualMonitor.vala"
			_tmp48_ = _tmp47_;
#line 105 "../src/Objects/VirtualMonitor.vala"
			_vala_height = _tmp48_;
#line 98 "../src/Objects/VirtualMonitor.vala"
			_g_object_unref0 (current_mode);
#line 406 "VirtualMonitor.c"
		}
	}
#line 83 "../src/Objects/VirtualMonitor.vala"
	if (width) {
#line 83 "../src/Objects/VirtualMonitor.vala"
		*width = _vala_width;
#line 413 "VirtualMonitor.c"
	}
#line 83 "../src/Objects/VirtualMonitor.vala"
	if (height) {
#line 83 "../src/Objects/VirtualMonitor.vala"
		*height = _vala_height;
#line 419 "VirtualMonitor.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 113 "../src/Objects/VirtualMonitor.vala"
	return self ? g_object_ref (self) : NULL;
#line 428 "VirtualMonitor.c"
}

GeeLinkedList*
display_virtual_monitor_get_available_modes (DisplayVirtualMonitor* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	GeeLinkedList* result;
#line 109 "../src/Objects/VirtualMonitor.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 110 "../src/Objects/VirtualMonitor.vala"
	_tmp0_ = display_virtual_monitor_get_is_mirror (self);
#line 110 "../src/Objects/VirtualMonitor.vala"
	_tmp1_ = _tmp0_;
#line 110 "../src/Objects/VirtualMonitor.vala"
	if (_tmp1_) {
#line 445 "VirtualMonitor.c"
		GeeLinkedList* _tmp2_;
		GeeLinkedList* _tmp3_;
#line 111 "../src/Objects/VirtualMonitor.vala"
		_tmp2_ = self->priv->_monitors;
#line 111 "../src/Objects/VirtualMonitor.vala"
		_tmp3_ = display_utils_get_common_monitor_modes (_tmp2_);
#line 111 "../src/Objects/VirtualMonitor.vala"
		result = _tmp3_;
#line 111 "../src/Objects/VirtualMonitor.vala"
		return result;
#line 456 "VirtualMonitor.c"
	} else {
		DisplayMonitor* _tmp4_;
		DisplayMonitor* _tmp5_;
		DisplayMonitor* _tmp6_;
		GeeLinkedList* _tmp7_;
		GeeLinkedList* _tmp8_;
		GeeLinkedList* _tmp9_;
		GeeLinkedList* _tmp10_;
#line 113 "../src/Objects/VirtualMonitor.vala"
		_tmp4_ = display_virtual_monitor_get_monitor (self);
#line 113 "../src/Objects/VirtualMonitor.vala"
		_tmp5_ = _tmp4_;
#line 113 "../src/Objects/VirtualMonitor.vala"
		_tmp6_ = _tmp5_;
#line 113 "../src/Objects/VirtualMonitor.vala"
		_tmp7_ = display_monitor_get_modes (_tmp6_);
#line 113 "../src/Objects/VirtualMonitor.vala"
		_tmp8_ = _tmp7_;
#line 113 "../src/Objects/VirtualMonitor.vala"
		_tmp9_ = _g_object_ref0 (_tmp8_);
#line 113 "../src/Objects/VirtualMonitor.vala"
		_tmp10_ = _tmp9_;
#line 113 "../src/Objects/VirtualMonitor.vala"
		_g_object_unref0 (_tmp6_);
#line 113 "../src/Objects/VirtualMonitor.vala"
		result = _tmp10_;
#line 113 "../src/Objects/VirtualMonitor.vala"
		return result;
#line 485 "VirtualMonitor.c"
	}
}

DisplayMonitorMode*
display_virtual_monitor_get_mode_for_resolution (DisplayVirtualMonitor* self,
                                                 gint width,
                                                 gint height)
{
	DisplayMonitorMode* result;
#line 117 "../src/Objects/VirtualMonitor.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 497 "VirtualMonitor.c"
	{
		GeeLinkedList* _mode_list = NULL;
		GeeLinkedList* _tmp0_;
		gint _mode_size = 0;
		GeeLinkedList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _mode_index = 0;
#line 118 "../src/Objects/VirtualMonitor.vala"
		_tmp0_ = display_virtual_monitor_get_available_modes (self);
#line 118 "../src/Objects/VirtualMonitor.vala"
		_mode_list = _tmp0_;
#line 118 "../src/Objects/VirtualMonitor.vala"
		_tmp1_ = _mode_list;
#line 118 "../src/Objects/VirtualMonitor.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 118 "../src/Objects/VirtualMonitor.vala"
		_tmp3_ = _tmp2_;
#line 118 "../src/Objects/VirtualMonitor.vala"
		_mode_size = _tmp3_;
#line 118 "../src/Objects/VirtualMonitor.vala"
		_mode_index = -1;
#line 118 "../src/Objects/VirtualMonitor.vala"
		while (TRUE) {
#line 522 "VirtualMonitor.c"
			gint _tmp4_;
			gint _tmp5_;
			DisplayMonitorMode* mode = NULL;
			GeeLinkedList* _tmp6_;
			gpointer _tmp7_;
			gboolean _tmp8_ = FALSE;
			DisplayMonitorMode* _tmp9_;
			gint _tmp10_;
			gint _tmp11_;
#line 118 "../src/Objects/VirtualMonitor.vala"
			_mode_index = _mode_index + 1;
#line 118 "../src/Objects/VirtualMonitor.vala"
			_tmp4_ = _mode_index;
#line 118 "../src/Objects/VirtualMonitor.vala"
			_tmp5_ = _mode_size;
#line 118 "../src/Objects/VirtualMonitor.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 118 "../src/Objects/VirtualMonitor.vala"
				break;
#line 542 "VirtualMonitor.c"
			}
#line 118 "../src/Objects/VirtualMonitor.vala"
			_tmp6_ = _mode_list;
#line 118 "../src/Objects/VirtualMonitor.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _mode_index);
#line 118 "../src/Objects/VirtualMonitor.vala"
			mode = (DisplayMonitorMode*) _tmp7_;
#line 119 "../src/Objects/VirtualMonitor.vala"
			_tmp9_ = mode;
#line 119 "../src/Objects/VirtualMonitor.vala"
			_tmp10_ = display_monitor_mode_get_width (_tmp9_);
#line 119 "../src/Objects/VirtualMonitor.vala"
			_tmp11_ = _tmp10_;
#line 119 "../src/Objects/VirtualMonitor.vala"
			if (_tmp11_ == width) {
#line 558 "VirtualMonitor.c"
				DisplayMonitorMode* _tmp12_;
				gint _tmp13_;
				gint _tmp14_;
#line 119 "../src/Objects/VirtualMonitor.vala"
				_tmp12_ = mode;
#line 119 "../src/Objects/VirtualMonitor.vala"
				_tmp13_ = display_monitor_mode_get_height (_tmp12_);
#line 119 "../src/Objects/VirtualMonitor.vala"
				_tmp14_ = _tmp13_;
#line 119 "../src/Objects/VirtualMonitor.vala"
				_tmp8_ = _tmp14_ == height;
#line 570 "VirtualMonitor.c"
			} else {
#line 119 "../src/Objects/VirtualMonitor.vala"
				_tmp8_ = FALSE;
#line 574 "VirtualMonitor.c"
			}
#line 119 "../src/Objects/VirtualMonitor.vala"
			if (_tmp8_) {
#line 120 "../src/Objects/VirtualMonitor.vala"
				result = mode;
#line 120 "../src/Objects/VirtualMonitor.vala"
				_g_object_unref0 (_mode_list);
#line 120 "../src/Objects/VirtualMonitor.vala"
				return result;
#line 584 "VirtualMonitor.c"
			}
#line 118 "../src/Objects/VirtualMonitor.vala"
			_g_object_unref0 (mode);
#line 588 "VirtualMonitor.c"
		}
#line 118 "../src/Objects/VirtualMonitor.vala"
		_g_object_unref0 (_mode_list);
#line 592 "VirtualMonitor.c"
	}
#line 124 "../src/Objects/VirtualMonitor.vala"
	result = NULL;
#line 124 "../src/Objects/VirtualMonitor.vala"
	return result;
#line 598 "VirtualMonitor.c"
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
#line 127 "../src/Objects/VirtualMonitor.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 127 "../src/Objects/VirtualMonitor.vala"
	return _data1_;
#line 608 "VirtualMonitor.c"
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 127 "../src/Objects/VirtualMonitor.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 618 "VirtualMonitor.c"
		DisplayVirtualMonitor* self;
#line 127 "../src/Objects/VirtualMonitor.vala"
		self = _data1_->self;
#line 127 "../src/Objects/VirtualMonitor.vala"
		_g_object_unref0 (_data1_->current_mode);
#line 127 "../src/Objects/VirtualMonitor.vala"
		_g_object_unref0 (self);
#line 127 "../src/Objects/VirtualMonitor.vala"
		g_slice_free (Block1Data, _data1_);
#line 628 "VirtualMonitor.c"
	}
}

static gboolean
___lambda4_ (Block1Data* _data1_,
             DisplayMonitor* _monitor)
{
	DisplayVirtualMonitor* self;
	gboolean mode_found = FALSE;
	gboolean result;
#line 129 "../src/Objects/VirtualMonitor.vala"
	self = _data1_->self;
#line 129 "../src/Objects/VirtualMonitor.vala"
	g_return_val_if_fail (_monitor != NULL, FALSE);
#line 130 "../src/Objects/VirtualMonitor.vala"
	mode_found = FALSE;
#line 645 "VirtualMonitor.c"
	{
		GeeLinkedList* _mode_list = NULL;
		GeeLinkedList* _tmp0_;
		GeeLinkedList* _tmp1_;
		gint _mode_size = 0;
		GeeLinkedList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _mode_index = 0;
#line 131 "../src/Objects/VirtualMonitor.vala"
		_tmp0_ = display_monitor_get_modes (_monitor);
#line 131 "../src/Objects/VirtualMonitor.vala"
		_tmp1_ = _tmp0_;
#line 131 "../src/Objects/VirtualMonitor.vala"
		_mode_list = _tmp1_;
#line 131 "../src/Objects/VirtualMonitor.vala"
		_tmp2_ = _mode_list;
#line 131 "../src/Objects/VirtualMonitor.vala"
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 131 "../src/Objects/VirtualMonitor.vala"
		_tmp4_ = _tmp3_;
#line 131 "../src/Objects/VirtualMonitor.vala"
		_mode_size = _tmp4_;
#line 131 "../src/Objects/VirtualMonitor.vala"
		_mode_index = -1;
#line 131 "../src/Objects/VirtualMonitor.vala"
		while (TRUE) {
#line 673 "VirtualMonitor.c"
			gint _tmp5_;
			gint _tmp6_;
			DisplayMonitorMode* mode = NULL;
			GeeLinkedList* _tmp7_;
			gpointer _tmp8_;
			gboolean _tmp10_ = FALSE;
			DisplayMonitorMode* _tmp11_;
			gint _tmp12_;
			gint _tmp13_;
			gint _tmp14_;
			gint _tmp15_;
#line 131 "../src/Objects/VirtualMonitor.vala"
			_mode_index = _mode_index + 1;
#line 131 "../src/Objects/VirtualMonitor.vala"
			_tmp5_ = _mode_index;
#line 131 "../src/Objects/VirtualMonitor.vala"
			_tmp6_ = _mode_size;
#line 131 "../src/Objects/VirtualMonitor.vala"
			if (!(_tmp5_ < _tmp6_)) {
#line 131 "../src/Objects/VirtualMonitor.vala"
				break;
#line 695 "VirtualMonitor.c"
			}
#line 131 "../src/Objects/VirtualMonitor.vala"
			_tmp7_ = _mode_list;
#line 131 "../src/Objects/VirtualMonitor.vala"
			_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, _mode_index);
#line 131 "../src/Objects/VirtualMonitor.vala"
			mode = (DisplayMonitorMode*) _tmp8_;
#line 132 "../src/Objects/VirtualMonitor.vala"
			if (mode_found) {
#line 705 "VirtualMonitor.c"
				DisplayMonitorMode* _tmp9_;
#line 133 "../src/Objects/VirtualMonitor.vala"
				_tmp9_ = mode;
#line 133 "../src/Objects/VirtualMonitor.vala"
				display_monitor_mode_set_is_current (_tmp9_, FALSE);
#line 134 "../src/Objects/VirtualMonitor.vala"
				_g_object_unref0 (mode);
#line 134 "../src/Objects/VirtualMonitor.vala"
				continue;
#line 715 "VirtualMonitor.c"
			}
#line 137 "../src/Objects/VirtualMonitor.vala"
			_tmp11_ = mode;
#line 137 "../src/Objects/VirtualMonitor.vala"
			_tmp12_ = display_monitor_mode_get_width (_tmp11_);
#line 137 "../src/Objects/VirtualMonitor.vala"
			_tmp13_ = _tmp12_;
#line 137 "../src/Objects/VirtualMonitor.vala"
			_tmp14_ = display_monitor_mode_get_width (_data1_->current_mode);
#line 137 "../src/Objects/VirtualMonitor.vala"
			_tmp15_ = _tmp14_;
#line 137 "../src/Objects/VirtualMonitor.vala"
			if (_tmp13_ == _tmp15_) {
#line 729 "VirtualMonitor.c"
				DisplayMonitorMode* _tmp16_;
				gint _tmp17_;
				gint _tmp18_;
				gint _tmp19_;
				gint _tmp20_;
#line 137 "../src/Objects/VirtualMonitor.vala"
				_tmp16_ = mode;
#line 137 "../src/Objects/VirtualMonitor.vala"
				_tmp17_ = display_monitor_mode_get_height (_tmp16_);
#line 137 "../src/Objects/VirtualMonitor.vala"
				_tmp18_ = _tmp17_;
#line 137 "../src/Objects/VirtualMonitor.vala"
				_tmp19_ = display_monitor_mode_get_height (_data1_->current_mode);
#line 137 "../src/Objects/VirtualMonitor.vala"
				_tmp20_ = _tmp19_;
#line 137 "../src/Objects/VirtualMonitor.vala"
				_tmp10_ = _tmp18_ == _tmp20_;
#line 747 "VirtualMonitor.c"
			} else {
#line 137 "../src/Objects/VirtualMonitor.vala"
				_tmp10_ = FALSE;
#line 751 "VirtualMonitor.c"
			}
#line 137 "../src/Objects/VirtualMonitor.vala"
			if (_tmp10_) {
#line 755 "VirtualMonitor.c"
				DisplayMonitorMode* _tmp21_;
#line 138 "../src/Objects/VirtualMonitor.vala"
				mode_found = TRUE;
#line 139 "../src/Objects/VirtualMonitor.vala"
				_tmp21_ = mode;
#line 139 "../src/Objects/VirtualMonitor.vala"
				display_monitor_mode_set_is_current (_tmp21_, TRUE);
#line 763 "VirtualMonitor.c"
			} else {
				DisplayMonitorMode* _tmp22_;
#line 141 "../src/Objects/VirtualMonitor.vala"
				_tmp22_ = mode;
#line 141 "../src/Objects/VirtualMonitor.vala"
				display_monitor_mode_set_is_current (_tmp22_, FALSE);
#line 770 "VirtualMonitor.c"
			}
#line 131 "../src/Objects/VirtualMonitor.vala"
			_g_object_unref0 (mode);
#line 774 "VirtualMonitor.c"
		}
	}
#line 145 "../src/Objects/VirtualMonitor.vala"
	result = TRUE;
#line 145 "../src/Objects/VirtualMonitor.vala"
	_g_object_unref0 (_monitor);
#line 145 "../src/Objects/VirtualMonitor.vala"
	return result;
#line 783 "VirtualMonitor.c"
}

static gboolean
____lambda4__gee_forall_func (gpointer g,
                              gpointer self)
{
	gboolean result;
	result = ___lambda4_ (self, (DisplayMonitor*) g);
#line 129 "../src/Objects/VirtualMonitor.vala"
	return result;
#line 794 "VirtualMonitor.c"
}

void
display_virtual_monitor_set_current_mode (DisplayVirtualMonitor* self,
                                          DisplayMonitorMode* current_mode)
{
	Block1Data* _data1_;
	DisplayMonitorMode* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 127 "../src/Objects/VirtualMonitor.vala"
	g_return_if_fail (self != NULL);
#line 127 "../src/Objects/VirtualMonitor.vala"
	g_return_if_fail (current_mode != NULL);
#line 127 "../src/Objects/VirtualMonitor.vala"
	_data1_ = g_slice_new0 (Block1Data);
#line 127 "../src/Objects/VirtualMonitor.vala"
	_data1_->_ref_count_ = 1;
#line 127 "../src/Objects/VirtualMonitor.vala"
	_data1_->self = g_object_ref (self);
#line 127 "../src/Objects/VirtualMonitor.vala"
	_tmp0_ = _g_object_ref0 (current_mode);
#line 127 "../src/Objects/VirtualMonitor.vala"
	_g_object_unref0 (_data1_->current_mode);
#line 127 "../src/Objects/VirtualMonitor.vala"
	_data1_->current_mode = _tmp0_;
#line 128 "../src/Objects/VirtualMonitor.vala"
	_tmp1_ = display_virtual_monitor_get_is_mirror (self);
#line 128 "../src/Objects/VirtualMonitor.vala"
	_tmp2_ = _tmp1_;
#line 128 "../src/Objects/VirtualMonitor.vala"
	if (_tmp2_) {
#line 827 "VirtualMonitor.c"
		GeeLinkedList* _tmp3_;
#line 129 "../src/Objects/VirtualMonitor.vala"
		_tmp3_ = self->priv->_monitors;
#line 129 "../src/Objects/VirtualMonitor.vala"
		gee_abstract_collection_foreach ((GeeAbstractCollection*) _tmp3_, ____lambda4__gee_forall_func, _data1_);
#line 833 "VirtualMonitor.c"
	} else {
		{
			GeeLinkedList* _mode_list = NULL;
			DisplayMonitor* _tmp4_;
			DisplayMonitor* _tmp5_;
			DisplayMonitor* _tmp6_;
			GeeLinkedList* _tmp7_;
			GeeLinkedList* _tmp8_;
			GeeLinkedList* _tmp9_;
			gint _mode_size = 0;
			GeeLinkedList* _tmp10_;
			gint _tmp11_;
			gint _tmp12_;
			gint _mode_index = 0;
#line 148 "../src/Objects/VirtualMonitor.vala"
			_tmp4_ = display_virtual_monitor_get_monitor (self);
#line 148 "../src/Objects/VirtualMonitor.vala"
			_tmp5_ = _tmp4_;
#line 148 "../src/Objects/VirtualMonitor.vala"
			_tmp6_ = _tmp5_;
#line 148 "../src/Objects/VirtualMonitor.vala"
			_tmp7_ = display_monitor_get_modes (_tmp6_);
#line 148 "../src/Objects/VirtualMonitor.vala"
			_tmp8_ = _tmp7_;
#line 148 "../src/Objects/VirtualMonitor.vala"
			_tmp9_ = _tmp8_;
#line 148 "../src/Objects/VirtualMonitor.vala"
			_g_object_unref0 (_tmp6_);
#line 148 "../src/Objects/VirtualMonitor.vala"
			_mode_list = _tmp9_;
#line 148 "../src/Objects/VirtualMonitor.vala"
			_tmp10_ = _mode_list;
#line 148 "../src/Objects/VirtualMonitor.vala"
			_tmp11_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp10_);
#line 148 "../src/Objects/VirtualMonitor.vala"
			_tmp12_ = _tmp11_;
#line 148 "../src/Objects/VirtualMonitor.vala"
			_mode_size = _tmp12_;
#line 148 "../src/Objects/VirtualMonitor.vala"
			_mode_index = -1;
#line 148 "../src/Objects/VirtualMonitor.vala"
			while (TRUE) {
#line 876 "VirtualMonitor.c"
				gint _tmp13_;
				gint _tmp14_;
				DisplayMonitorMode* mode = NULL;
				GeeLinkedList* _tmp15_;
				gpointer _tmp16_;
				DisplayMonitorMode* _tmp17_;
				DisplayMonitorMode* _tmp18_;
#line 148 "../src/Objects/VirtualMonitor.vala"
				_mode_index = _mode_index + 1;
#line 148 "../src/Objects/VirtualMonitor.vala"
				_tmp13_ = _mode_index;
#line 148 "../src/Objects/VirtualMonitor.vala"
				_tmp14_ = _mode_size;
#line 148 "../src/Objects/VirtualMonitor.vala"
				if (!(_tmp13_ < _tmp14_)) {
#line 148 "../src/Objects/VirtualMonitor.vala"
					break;
#line 894 "VirtualMonitor.c"
				}
#line 148 "../src/Objects/VirtualMonitor.vala"
				_tmp15_ = _mode_list;
#line 148 "../src/Objects/VirtualMonitor.vala"
				_tmp16_ = gee_abstract_list_get ((GeeAbstractList*) _tmp15_, _mode_index);
#line 148 "../src/Objects/VirtualMonitor.vala"
				mode = (DisplayMonitorMode*) _tmp16_;
#line 149 "../src/Objects/VirtualMonitor.vala"
				_tmp17_ = mode;
#line 149 "../src/Objects/VirtualMonitor.vala"
				_tmp18_ = mode;
#line 149 "../src/Objects/VirtualMonitor.vala"
				display_monitor_mode_set_is_current (_tmp17_, _tmp18_ == _data1_->current_mode);
#line 148 "../src/Objects/VirtualMonitor.vala"
				_g_object_unref0 (mode);
#line 910 "VirtualMonitor.c"
			}
		}
	}
#line 127 "../src/Objects/VirtualMonitor.vala"
	block1_data_unref (_data1_);
#line 127 "../src/Objects/VirtualMonitor.vala"
	_data1_ = NULL;
#line 918 "VirtualMonitor.c"
}

gchar*
display_virtual_monitor_generate_id_from_monitors (MutterReadMonitorInfo* infos,
                                                   gint infos_length1)
{
	guint val = 0U;
	gchar* _tmp5_;
	gchar* result;
#line 155 "../src/Objects/VirtualMonitor.vala"
	val = (guint) 0;
#line 930 "VirtualMonitor.c"
	{
		MutterReadMonitorInfo* info_collection = NULL;
		gint info_collection_length1 = 0;
		gint _info_collection_size_ = 0;
		gint info_it = 0;
#line 156 "../src/Objects/VirtualMonitor.vala"
		info_collection = infos;
#line 156 "../src/Objects/VirtualMonitor.vala"
		info_collection_length1 = infos_length1;
#line 156 "../src/Objects/VirtualMonitor.vala"
		for (info_it = 0; info_it < info_collection_length1; info_it = info_it + 1) {
#line 942 "VirtualMonitor.c"
			MutterReadMonitorInfo _tmp0_;
			MutterReadMonitorInfo _tmp1_ = {0};
			MutterReadMonitorInfo info = {0};
#line 156 "../src/Objects/VirtualMonitor.vala"
			_tmp0_ = info_collection[info_it];
#line 156 "../src/Objects/VirtualMonitor.vala"
			mutter_read_monitor_info_copy (&_tmp0_, &_tmp1_);
#line 156 "../src/Objects/VirtualMonitor.vala"
			info = _tmp1_;
#line 952 "VirtualMonitor.c"
			{
				MutterReadMonitorInfo _tmp2_;
				guint _tmp3_;
				guint _tmp4_;
#line 157 "../src/Objects/VirtualMonitor.vala"
				_tmp2_ = info;
#line 157 "../src/Objects/VirtualMonitor.vala"
				_tmp3_ = mutter_read_monitor_info_get_hash (&_tmp2_);
#line 157 "../src/Objects/VirtualMonitor.vala"
				_tmp4_ = _tmp3_;
#line 157 "../src/Objects/VirtualMonitor.vala"
				val += _tmp4_;
#line 156 "../src/Objects/VirtualMonitor.vala"
				mutter_read_monitor_info_destroy (&info);
#line 967 "VirtualMonitor.c"
			}
		}
	}
#line 160 "../src/Objects/VirtualMonitor.vala"
	_tmp5_ = g_strdup_printf ("%u", val);
#line 160 "../src/Objects/VirtualMonitor.vala"
	result = _tmp5_;
#line 160 "../src/Objects/VirtualMonitor.vala"
	return result;
#line 977 "VirtualMonitor.c"
}

DisplayVirtualMonitor*
display_virtual_monitor_construct (GType object_type)
{
	DisplayVirtualMonitor * self = NULL;
#line 22 "../src/Objects/VirtualMonitor.vala"
	self = (DisplayVirtualMonitor*) g_object_new (object_type, NULL);
#line 22 "../src/Objects/VirtualMonitor.vala"
	return self;
#line 988 "VirtualMonitor.c"
}

DisplayVirtualMonitor*
display_virtual_monitor_new (void)
{
#line 22 "../src/Objects/VirtualMonitor.vala"
	return display_virtual_monitor_construct (DISPLAY_TYPE_VIRTUAL_MONITOR);
#line 996 "VirtualMonitor.c"
}

gint
display_virtual_monitor_get_x (DisplayVirtualMonitor* self)
{
	gint result;
#line 23 "../src/Objects/VirtualMonitor.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 23 "../src/Objects/VirtualMonitor.vala"
	result = self->priv->_x;
#line 23 "../src/Objects/VirtualMonitor.vala"
	return result;
#line 1009 "VirtualMonitor.c"
}

void
display_virtual_monitor_set_x (DisplayVirtualMonitor* self,
                               gint value)
{
	gint old_value;
#line 23 "../src/Objects/VirtualMonitor.vala"
	g_return_if_fail (self != NULL);
#line 23 "../src/Objects/VirtualMonitor.vala"
	old_value = display_virtual_monitor_get_x (self);
#line 23 "../src/Objects/VirtualMonitor.vala"
	if (old_value != value) {
#line 23 "../src/Objects/VirtualMonitor.vala"
		self->priv->_x = value;
#line 23 "../src/Objects/VirtualMonitor.vala"
		g_object_notify_by_pspec ((GObject *) self, display_virtual_monitor_properties[DISPLAY_VIRTUAL_MONITOR_X_PROPERTY]);
#line 1027 "VirtualMonitor.c"
	}
}

gint
display_virtual_monitor_get_y (DisplayVirtualMonitor* self)
{
	gint result;
#line 24 "../src/Objects/VirtualMonitor.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 24 "../src/Objects/VirtualMonitor.vala"
	result = self->priv->_y;
#line 24 "../src/Objects/VirtualMonitor.vala"
	return result;
#line 1041 "VirtualMonitor.c"
}

void
display_virtual_monitor_set_y (DisplayVirtualMonitor* self,
                               gint value)
{
	gint old_value;
#line 24 "../src/Objects/VirtualMonitor.vala"
	g_return_if_fail (self != NULL);
#line 24 "../src/Objects/VirtualMonitor.vala"
	old_value = display_virtual_monitor_get_y (self);
#line 24 "../src/Objects/VirtualMonitor.vala"
	if (old_value != value) {
#line 24 "../src/Objects/VirtualMonitor.vala"
		self->priv->_y = value;
#line 24 "../src/Objects/VirtualMonitor.vala"
		g_object_notify_by_pspec ((GObject *) self, display_virtual_monitor_properties[DISPLAY_VIRTUAL_MONITOR_Y_PROPERTY]);
#line 1059 "VirtualMonitor.c"
	}
}

gint
display_virtual_monitor_get_current_x (DisplayVirtualMonitor* self)
{
	gint result;
#line 25 "../src/Objects/VirtualMonitor.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 25 "../src/Objects/VirtualMonitor.vala"
	result = self->priv->_current_x;
#line 25 "../src/Objects/VirtualMonitor.vala"
	return result;
#line 1073 "VirtualMonitor.c"
}

void
display_virtual_monitor_set_current_x (DisplayVirtualMonitor* self,
                                       gint value)
{
	gint old_value;
#line 25 "../src/Objects/VirtualMonitor.vala"
	g_return_if_fail (self != NULL);
#line 25 "../src/Objects/VirtualMonitor.vala"
	old_value = display_virtual_monitor_get_current_x (self);
#line 25 "../src/Objects/VirtualMonitor.vala"
	if (old_value != value) {
#line 25 "../src/Objects/VirtualMonitor.vala"
		self->priv->_current_x = value;
#line 25 "../src/Objects/VirtualMonitor.vala"
		g_object_notify_by_pspec ((GObject *) self, display_virtual_monitor_properties[DISPLAY_VIRTUAL_MONITOR_CURRENT_X_PROPERTY]);
#line 1091 "VirtualMonitor.c"
	}
}

gint
display_virtual_monitor_get_current_y (DisplayVirtualMonitor* self)
{
	gint result;
#line 26 "../src/Objects/VirtualMonitor.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 26 "../src/Objects/VirtualMonitor.vala"
	result = self->priv->_current_y;
#line 26 "../src/Objects/VirtualMonitor.vala"
	return result;
#line 1105 "VirtualMonitor.c"
}

void
display_virtual_monitor_set_current_y (DisplayVirtualMonitor* self,
                                       gint value)
{
	gint old_value;
#line 26 "../src/Objects/VirtualMonitor.vala"
	g_return_if_fail (self != NULL);
#line 26 "../src/Objects/VirtualMonitor.vala"
	old_value = display_virtual_monitor_get_current_y (self);
#line 26 "../src/Objects/VirtualMonitor.vala"
	if (old_value != value) {
#line 26 "../src/Objects/VirtualMonitor.vala"
		self->priv->_current_y = value;
#line 26 "../src/Objects/VirtualMonitor.vala"
		g_object_notify_by_pspec ((GObject *) self, display_virtual_monitor_properties[DISPLAY_VIRTUAL_MONITOR_CURRENT_Y_PROPERTY]);
#line 1123 "VirtualMonitor.c"
	}
}

gdouble
display_virtual_monitor_get_scale (DisplayVirtualMonitor* self)
{
	gdouble result;
#line 27 "../src/Objects/VirtualMonitor.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 27 "../src/Objects/VirtualMonitor.vala"
	result = self->priv->_scale;
#line 27 "../src/Objects/VirtualMonitor.vala"
	return result;
#line 1137 "VirtualMonitor.c"
}

void
display_virtual_monitor_set_scale (DisplayVirtualMonitor* self,
                                   gdouble value)
{
	gdouble old_value;
#line 27 "../src/Objects/VirtualMonitor.vala"
	g_return_if_fail (self != NULL);
#line 27 "../src/Objects/VirtualMonitor.vala"
	old_value = display_virtual_monitor_get_scale (self);
#line 27 "../src/Objects/VirtualMonitor.vala"
	if (old_value != value) {
#line 27 "../src/Objects/VirtualMonitor.vala"
		self->priv->_scale = value;
#line 27 "../src/Objects/VirtualMonitor.vala"
		g_object_notify_by_pspec ((GObject *) self, display_virtual_monitor_properties[DISPLAY_VIRTUAL_MONITOR_SCALE_PROPERTY]);
#line 1155 "VirtualMonitor.c"
	}
}

DisplayTransform
display_virtual_monitor_get_transform (DisplayVirtualMonitor* self)
{
	DisplayTransform result;
#line 28 "../src/Objects/VirtualMonitor.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 28 "../src/Objects/VirtualMonitor.vala"
	result = self->priv->_transform;
#line 28 "../src/Objects/VirtualMonitor.vala"
	return result;
#line 1169 "VirtualMonitor.c"
}

void
display_virtual_monitor_set_transform (DisplayVirtualMonitor* self,
                                       DisplayTransform value)
{
	DisplayTransform old_value;
#line 28 "../src/Objects/VirtualMonitor.vala"
	g_return_if_fail (self != NULL);
#line 28 "../src/Objects/VirtualMonitor.vala"
	old_value = display_virtual_monitor_get_transform (self);
#line 28 "../src/Objects/VirtualMonitor.vala"
	if (old_value != value) {
#line 28 "../src/Objects/VirtualMonitor.vala"
		self->priv->_transform = value;
#line 28 "../src/Objects/VirtualMonitor.vala"
		g_object_notify_by_pspec ((GObject *) self, display_virtual_monitor_properties[DISPLAY_VIRTUAL_MONITOR_TRANSFORM_PROPERTY]);
#line 1187 "VirtualMonitor.c"
	}
}

gboolean
display_virtual_monitor_get_primary (DisplayVirtualMonitor* self)
{
	gboolean result;
#line 29 "../src/Objects/VirtualMonitor.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 29 "../src/Objects/VirtualMonitor.vala"
	result = self->priv->_primary;
#line 29 "../src/Objects/VirtualMonitor.vala"
	return result;
#line 1201 "VirtualMonitor.c"
}

void
display_virtual_monitor_set_primary (DisplayVirtualMonitor* self,
                                     gboolean value)
{
	gboolean old_value;
#line 29 "../src/Objects/VirtualMonitor.vala"
	g_return_if_fail (self != NULL);
#line 29 "../src/Objects/VirtualMonitor.vala"
	old_value = display_virtual_monitor_get_primary (self);
#line 29 "../src/Objects/VirtualMonitor.vala"
	if (old_value != value) {
#line 29 "../src/Objects/VirtualMonitor.vala"
		self->priv->_primary = value;
#line 29 "../src/Objects/VirtualMonitor.vala"
		g_object_notify_by_pspec ((GObject *) self, display_virtual_monitor_properties[DISPLAY_VIRTUAL_MONITOR_PRIMARY_PROPERTY]);
#line 1219 "VirtualMonitor.c"
	}
}

GeeLinkedList*
display_virtual_monitor_get_monitors (DisplayVirtualMonitor* self)
{
	GeeLinkedList* result;
	GeeLinkedList* _tmp0_;
#line 30 "../src/Objects/VirtualMonitor.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 30 "../src/Objects/VirtualMonitor.vala"
	_tmp0_ = self->priv->_monitors;
#line 30 "../src/Objects/VirtualMonitor.vala"
	result = _tmp0_;
#line 30 "../src/Objects/VirtualMonitor.vala"
	return result;
#line 1236 "VirtualMonitor.c"
}

static void
display_virtual_monitor_set_monitors (DisplayVirtualMonitor* self,
                                      GeeLinkedList* value)
{
	GeeLinkedList* old_value;
#line 30 "../src/Objects/VirtualMonitor.vala"
	g_return_if_fail (self != NULL);
#line 30 "../src/Objects/VirtualMonitor.vala"
	old_value = display_virtual_monitor_get_monitors (self);
#line 30 "../src/Objects/VirtualMonitor.vala"
	if (old_value != value) {
#line 1250 "VirtualMonitor.c"
		GeeLinkedList* _tmp0_;
#line 30 "../src/Objects/VirtualMonitor.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 30 "../src/Objects/VirtualMonitor.vala"
		_g_object_unref0 (self->priv->_monitors);
#line 30 "../src/Objects/VirtualMonitor.vala"
		self->priv->_monitors = _tmp0_;
#line 30 "../src/Objects/VirtualMonitor.vala"
		g_object_notify_by_pspec ((GObject *) self, display_virtual_monitor_properties[DISPLAY_VIRTUAL_MONITOR_MONITORS_PROPERTY]);
#line 1260 "VirtualMonitor.c"
	}
}

gchar*
display_virtual_monitor_get_id (DisplayVirtualMonitor* self)
{
	gchar* result;
	guint val = 0U;
	gchar* _tmp11_;
#line 40 "../src/Objects/VirtualMonitor.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 41 "../src/Objects/VirtualMonitor.vala"
	val = (guint) 0;
#line 1274 "VirtualMonitor.c"
	{
		GeeLinkedList* _monitor_list = NULL;
		GeeLinkedList* _tmp0_;
		gint _monitor_size = 0;
		GeeLinkedList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _monitor_index = 0;
#line 42 "../src/Objects/VirtualMonitor.vala"
		_tmp0_ = self->priv->_monitors;
#line 42 "../src/Objects/VirtualMonitor.vala"
		_monitor_list = _tmp0_;
#line 42 "../src/Objects/VirtualMonitor.vala"
		_tmp1_ = _monitor_list;
#line 42 "../src/Objects/VirtualMonitor.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 42 "../src/Objects/VirtualMonitor.vala"
		_tmp3_ = _tmp2_;
#line 42 "../src/Objects/VirtualMonitor.vala"
		_monitor_size = _tmp3_;
#line 42 "../src/Objects/VirtualMonitor.vala"
		_monitor_index = -1;
#line 42 "../src/Objects/VirtualMonitor.vala"
		while (TRUE) {
#line 1299 "VirtualMonitor.c"
			gint _tmp4_;
			gint _tmp5_;
			DisplayMonitor* monitor = NULL;
			GeeLinkedList* _tmp6_;
			gpointer _tmp7_;
			DisplayMonitor* _tmp8_;
			guint _tmp9_;
			guint _tmp10_;
#line 42 "../src/Objects/VirtualMonitor.vala"
			_monitor_index = _monitor_index + 1;
#line 42 "../src/Objects/VirtualMonitor.vala"
			_tmp4_ = _monitor_index;
#line 42 "../src/Objects/VirtualMonitor.vala"
			_tmp5_ = _monitor_size;
#line 42 "../src/Objects/VirtualMonitor.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 42 "../src/Objects/VirtualMonitor.vala"
				break;
#line 1318 "VirtualMonitor.c"
			}
#line 42 "../src/Objects/VirtualMonitor.vala"
			_tmp6_ = _monitor_list;
#line 42 "../src/Objects/VirtualMonitor.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _monitor_index);
#line 42 "../src/Objects/VirtualMonitor.vala"
			monitor = (DisplayMonitor*) _tmp7_;
#line 43 "../src/Objects/VirtualMonitor.vala"
			_tmp8_ = monitor;
#line 43 "../src/Objects/VirtualMonitor.vala"
			_tmp9_ = display_monitor_get_hash (_tmp8_);
#line 43 "../src/Objects/VirtualMonitor.vala"
			_tmp10_ = _tmp9_;
#line 43 "../src/Objects/VirtualMonitor.vala"
			val += _tmp10_;
#line 42 "../src/Objects/VirtualMonitor.vala"
			_g_object_unref0 (monitor);
#line 1336 "VirtualMonitor.c"
		}
	}
#line 46 "../src/Objects/VirtualMonitor.vala"
	_tmp11_ = g_strdup_printf ("%u", val);
#line 46 "../src/Objects/VirtualMonitor.vala"
	result = _tmp11_;
#line 46 "../src/Objects/VirtualMonitor.vala"
	return result;
#line 1345 "VirtualMonitor.c"
}

gboolean
display_virtual_monitor_get_is_mirror (DisplayVirtualMonitor* self)
{
	gboolean result;
	GeeLinkedList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 51 "../src/Objects/VirtualMonitor.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 52 "../src/Objects/VirtualMonitor.vala"
	_tmp0_ = self->priv->_monitors;
#line 52 "../src/Objects/VirtualMonitor.vala"
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 52 "../src/Objects/VirtualMonitor.vala"
	_tmp2_ = _tmp1_;
#line 52 "../src/Objects/VirtualMonitor.vala"
	result = _tmp2_ > 1;
#line 52 "../src/Objects/VirtualMonitor.vala"
	return result;
#line 1367 "VirtualMonitor.c"
}

gboolean
display_virtual_monitor_get_is_active (DisplayVirtualMonitor* self)
{
	gboolean result;
#line 56 "../src/Objects/VirtualMonitor.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 56 "../src/Objects/VirtualMonitor.vala"
	result = self->priv->_is_active;
#line 56 "../src/Objects/VirtualMonitor.vala"
	return result;
#line 1380 "VirtualMonitor.c"
}

void
display_virtual_monitor_set_is_active (DisplayVirtualMonitor* self,
                                       gboolean value)
{
	gboolean old_value;
#line 56 "../src/Objects/VirtualMonitor.vala"
	g_return_if_fail (self != NULL);
#line 56 "../src/Objects/VirtualMonitor.vala"
	old_value = display_virtual_monitor_get_is_active (self);
#line 56 "../src/Objects/VirtualMonitor.vala"
	if (old_value != value) {
#line 56 "../src/Objects/VirtualMonitor.vala"
		self->priv->_is_active = value;
#line 56 "../src/Objects/VirtualMonitor.vala"
		g_object_notify_by_pspec ((GObject *) self, display_virtual_monitor_properties[DISPLAY_VIRTUAL_MONITOR_IS_ACTIVE_PROPERTY]);
#line 1398 "VirtualMonitor.c"
	}
}

DisplayMonitor*
display_virtual_monitor_get_monitor (DisplayVirtualMonitor* self)
{
	DisplayMonitor* result;
	gboolean _tmp0_;
	gboolean _tmp1_;
	GeeLinkedList* _tmp2_;
	gpointer _tmp3_;
#line 62 "../src/Objects/VirtualMonitor.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 63 "../src/Objects/VirtualMonitor.vala"
	_tmp0_ = display_virtual_monitor_get_is_mirror (self);
#line 63 "../src/Objects/VirtualMonitor.vala"
	_tmp1_ = _tmp0_;
#line 63 "../src/Objects/VirtualMonitor.vala"
	if (_tmp1_) {
#line 64 "../src/Objects/VirtualMonitor.vala"
		g_critical ("VirtualMonitor.vala:64: Do not use Display.VirtualMonitor.monitor in a" \
" mirror context!");
#line 1420 "VirtualMonitor.c"
	}
#line 67 "../src/Objects/VirtualMonitor.vala"
	_tmp2_ = self->priv->_monitors;
#line 67 "../src/Objects/VirtualMonitor.vala"
	_tmp3_ = gee_abstract_list_get ((GeeAbstractList*) _tmp2_, 0);
#line 67 "../src/Objects/VirtualMonitor.vala"
	result = (DisplayMonitor*) _tmp3_;
#line 67 "../src/Objects/VirtualMonitor.vala"
	return result;
#line 1430 "VirtualMonitor.c"
}

static GObject *
display_virtual_monitor_constructor (GType type,
                                     guint n_construct_properties,
                                     GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	DisplayVirtualMonitor * self;
	GeeLinkedList* _tmp0_;
	GeeLinkedList* _tmp1_;
#line 71 "../src/Objects/VirtualMonitor.vala"
	parent_class = G_OBJECT_CLASS (display_virtual_monitor_parent_class);
#line 71 "../src/Objects/VirtualMonitor.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 71 "../src/Objects/VirtualMonitor.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DISPLAY_TYPE_VIRTUAL_MONITOR, DisplayVirtualMonitor);
#line 72 "../src/Objects/VirtualMonitor.vala"
	_tmp0_ = gee_linked_list_new (DISPLAY_TYPE_MONITOR, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 72 "../src/Objects/VirtualMonitor.vala"
	_tmp1_ = _tmp0_;
#line 72 "../src/Objects/VirtualMonitor.vala"
	display_virtual_monitor_set_monitors (self, _tmp1_);
#line 72 "../src/Objects/VirtualMonitor.vala"
	_g_object_unref0 (_tmp1_);
#line 71 "../src/Objects/VirtualMonitor.vala"
	return obj;
#line 1459 "VirtualMonitor.c"
}

static void
display_virtual_monitor_class_init (DisplayVirtualMonitorClass * klass,
                                    gpointer klass_data)
{
#line 22 "../src/Objects/VirtualMonitor.vala"
	display_virtual_monitor_parent_class = g_type_class_peek_parent (klass);
#line 22 "../src/Objects/VirtualMonitor.vala"
	g_type_class_adjust_private_offset (klass, &DisplayVirtualMonitor_private_offset);
#line 22 "../src/Objects/VirtualMonitor.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_display_virtual_monitor_get_property;
#line 22 "../src/Objects/VirtualMonitor.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_display_virtual_monitor_set_property;
#line 22 "../src/Objects/VirtualMonitor.vala"
	G_OBJECT_CLASS (klass)->constructor = display_virtual_monitor_constructor;
#line 22 "../src/Objects/VirtualMonitor.vala"
	G_OBJECT_CLASS (klass)->finalize = display_virtual_monitor_finalize;
#line 22 "../src/Objects/VirtualMonitor.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_VIRTUAL_MONITOR_X_PROPERTY, display_virtual_monitor_properties[DISPLAY_VIRTUAL_MONITOR_X_PROPERTY] = g_param_spec_int ("x", "x", "x", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../src/Objects/VirtualMonitor.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_VIRTUAL_MONITOR_Y_PROPERTY, display_virtual_monitor_properties[DISPLAY_VIRTUAL_MONITOR_Y_PROPERTY] = g_param_spec_int ("y", "y", "y", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../src/Objects/VirtualMonitor.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_VIRTUAL_MONITOR_CURRENT_X_PROPERTY, display_virtual_monitor_properties[DISPLAY_VIRTUAL_MONITOR_CURRENT_X_PROPERTY] = g_param_spec_int ("current-x", "current-x", "current-x", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../src/Objects/VirtualMonitor.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_VIRTUAL_MONITOR_CURRENT_Y_PROPERTY, display_virtual_monitor_properties[DISPLAY_VIRTUAL_MONITOR_CURRENT_Y_PROPERTY] = g_param_spec_int ("current-y", "current-y", "current-y", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../src/Objects/VirtualMonitor.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_VIRTUAL_MONITOR_SCALE_PROPERTY, display_virtual_monitor_properties[DISPLAY_VIRTUAL_MONITOR_SCALE_PROPERTY] = g_param_spec_double ("scale", "scale", "scale", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../src/Objects/VirtualMonitor.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_VIRTUAL_MONITOR_TRANSFORM_PROPERTY, display_virtual_monitor_properties[DISPLAY_VIRTUAL_MONITOR_TRANSFORM_PROPERTY] = g_param_spec_enum ("transform", "transform", "transform", TYPE_DISPLAY_TRANSFORM, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../src/Objects/VirtualMonitor.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_VIRTUAL_MONITOR_PRIMARY_PROPERTY, display_virtual_monitor_properties[DISPLAY_VIRTUAL_MONITOR_PRIMARY_PROPERTY] = g_param_spec_boolean ("primary", "primary", "primary", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../src/Objects/VirtualMonitor.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_VIRTUAL_MONITOR_MONITORS_PROPERTY, display_virtual_monitor_properties[DISPLAY_VIRTUAL_MONITOR_MONITORS_PROPERTY] = g_param_spec_object ("monitors", "monitors", "monitors", GEE_TYPE_LINKED_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 22 "../src/Objects/VirtualMonitor.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_VIRTUAL_MONITOR_ID_PROPERTY, display_virtual_monitor_properties[DISPLAY_VIRTUAL_MONITOR_ID_PROPERTY] = g_param_spec_string ("id", "id", "id", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "../src/Objects/VirtualMonitor.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_VIRTUAL_MONITOR_IS_MIRROR_PROPERTY, display_virtual_monitor_properties[DISPLAY_VIRTUAL_MONITOR_IS_MIRROR_PROPERTY] = g_param_spec_boolean ("is-mirror", "is-mirror", "is-mirror", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "../src/Objects/VirtualMonitor.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_VIRTUAL_MONITOR_IS_ACTIVE_PROPERTY, display_virtual_monitor_properties[DISPLAY_VIRTUAL_MONITOR_IS_ACTIVE_PROPERTY] = g_param_spec_boolean ("is-active", "is-active", "is-active", TRUE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../src/Objects/VirtualMonitor.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_VIRTUAL_MONITOR_MONITOR_PROPERTY, display_virtual_monitor_properties[DISPLAY_VIRTUAL_MONITOR_MONITOR_PROPERTY] = g_param_spec_object ("monitor", "monitor", "monitor", DISPLAY_TYPE_MONITOR, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "../src/Objects/VirtualMonitor.vala"
	display_virtual_monitor_signals[DISPLAY_VIRTUAL_MONITOR_MODES_CHANGED_SIGNAL] = g_signal_new ("modes-changed", DISPLAY_TYPE_VIRTUAL_MONITOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1504 "VirtualMonitor.c"
}

static void
display_virtual_monitor_instance_init (DisplayVirtualMonitor * self,
                                       gpointer klass)
{
#line 22 "../src/Objects/VirtualMonitor.vala"
	self->priv = display_virtual_monitor_get_instance_private (self);
#line 56 "../src/Objects/VirtualMonitor.vala"
	self->priv->_is_active = TRUE;
#line 1515 "VirtualMonitor.c"
}

static void
display_virtual_monitor_finalize (GObject * obj)
{
	DisplayVirtualMonitor * self;
#line 22 "../src/Objects/VirtualMonitor.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DISPLAY_TYPE_VIRTUAL_MONITOR, DisplayVirtualMonitor);
#line 30 "../src/Objects/VirtualMonitor.vala"
	_g_object_unref0 (self->priv->_monitors);
#line 22 "../src/Objects/VirtualMonitor.vala"
	G_OBJECT_CLASS (display_virtual_monitor_parent_class)->finalize (obj);
#line 1528 "VirtualMonitor.c"
}

static GType
display_virtual_monitor_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DisplayVirtualMonitorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) display_virtual_monitor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DisplayVirtualMonitor), 0, (GInstanceInitFunc) display_virtual_monitor_instance_init, NULL };
	GType display_virtual_monitor_type_id;
	display_virtual_monitor_type_id = g_type_register_static (G_TYPE_OBJECT, "DisplayVirtualMonitor", &g_define_type_info, 0);
	DisplayVirtualMonitor_private_offset = g_type_add_instance_private (display_virtual_monitor_type_id, sizeof (DisplayVirtualMonitorPrivate));
	return display_virtual_monitor_type_id;
}

GType
display_virtual_monitor_get_type (void)
{
	static volatile gsize display_virtual_monitor_type_id__once = 0;
	if (g_once_init_enter (&display_virtual_monitor_type_id__once)) {
		GType display_virtual_monitor_type_id;
		display_virtual_monitor_type_id = display_virtual_monitor_get_type_once ();
		g_once_init_leave (&display_virtual_monitor_type_id__once, display_virtual_monitor_type_id);
	}
	return display_virtual_monitor_type_id__once;
}

static void
_vala_display_virtual_monitor_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec)
{
	DisplayVirtualMonitor * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DISPLAY_TYPE_VIRTUAL_MONITOR, DisplayVirtualMonitor);
#line 22 "../src/Objects/VirtualMonitor.vala"
	switch (property_id) {
#line 22 "../src/Objects/VirtualMonitor.vala"
		case DISPLAY_VIRTUAL_MONITOR_X_PROPERTY:
#line 22 "../src/Objects/VirtualMonitor.vala"
		g_value_set_int (value, display_virtual_monitor_get_x (self));
#line 22 "../src/Objects/VirtualMonitor.vala"
		break;
#line 22 "../src/Objects/VirtualMonitor.vala"
		case DISPLAY_VIRTUAL_MONITOR_Y_PROPERTY:
#line 22 "../src/Objects/VirtualMonitor.vala"
		g_value_set_int (value, display_virtual_monitor_get_y (self));
#line 22 "../src/Objects/VirtualMonitor.vala"
		break;
#line 22 "../src/Objects/VirtualMonitor.vala"
		case DISPLAY_VIRTUAL_MONITOR_CURRENT_X_PROPERTY:
#line 22 "../src/Objects/VirtualMonitor.vala"
		g_value_set_int (value, display_virtual_monitor_get_current_x (self));
#line 22 "../src/Objects/VirtualMonitor.vala"
		break;
#line 22 "../src/Objects/VirtualMonitor.vala"
		case DISPLAY_VIRTUAL_MONITOR_CURRENT_Y_PROPERTY:
#line 22 "../src/Objects/VirtualMonitor.vala"
		g_value_set_int (value, display_virtual_monitor_get_current_y (self));
#line 22 "../src/Objects/VirtualMonitor.vala"
		break;
#line 22 "../src/Objects/VirtualMonitor.vala"
		case DISPLAY_VIRTUAL_MONITOR_SCALE_PROPERTY:
#line 22 "../src/Objects/VirtualMonitor.vala"
		g_value_set_double (value, display_virtual_monitor_get_scale (self));
#line 22 "../src/Objects/VirtualMonitor.vala"
		break;
#line 22 "../src/Objects/VirtualMonitor.vala"
		case DISPLAY_VIRTUAL_MONITOR_TRANSFORM_PROPERTY:
#line 22 "../src/Objects/VirtualMonitor.vala"
		g_value_set_enum (value, display_virtual_monitor_get_transform (self));
#line 22 "../src/Objects/VirtualMonitor.vala"
		break;
#line 22 "../src/Objects/VirtualMonitor.vala"
		case DISPLAY_VIRTUAL_MONITOR_PRIMARY_PROPERTY:
#line 22 "../src/Objects/VirtualMonitor.vala"
		g_value_set_boolean (value, display_virtual_monitor_get_primary (self));
#line 22 "../src/Objects/VirtualMonitor.vala"
		break;
#line 22 "../src/Objects/VirtualMonitor.vala"
		case DISPLAY_VIRTUAL_MONITOR_MONITORS_PROPERTY:
#line 22 "../src/Objects/VirtualMonitor.vala"
		g_value_set_object (value, display_virtual_monitor_get_monitors (self));
#line 22 "../src/Objects/VirtualMonitor.vala"
		break;
#line 22 "../src/Objects/VirtualMonitor.vala"
		case DISPLAY_VIRTUAL_MONITOR_ID_PROPERTY:
#line 22 "../src/Objects/VirtualMonitor.vala"
		g_value_take_string (value, display_virtual_monitor_get_id (self));
#line 22 "../src/Objects/VirtualMonitor.vala"
		break;
#line 22 "../src/Objects/VirtualMonitor.vala"
		case DISPLAY_VIRTUAL_MONITOR_IS_MIRROR_PROPERTY:
#line 22 "../src/Objects/VirtualMonitor.vala"
		g_value_set_boolean (value, display_virtual_monitor_get_is_mirror (self));
#line 22 "../src/Objects/VirtualMonitor.vala"
		break;
#line 22 "../src/Objects/VirtualMonitor.vala"
		case DISPLAY_VIRTUAL_MONITOR_IS_ACTIVE_PROPERTY:
#line 22 "../src/Objects/VirtualMonitor.vala"
		g_value_set_boolean (value, display_virtual_monitor_get_is_active (self));
#line 22 "../src/Objects/VirtualMonitor.vala"
		break;
#line 22 "../src/Objects/VirtualMonitor.vala"
		case DISPLAY_VIRTUAL_MONITOR_MONITOR_PROPERTY:
#line 22 "../src/Objects/VirtualMonitor.vala"
		g_value_take_object (value, display_virtual_monitor_get_monitor (self));
#line 22 "../src/Objects/VirtualMonitor.vala"
		break;
#line 1635 "VirtualMonitor.c"
		default:
#line 22 "../src/Objects/VirtualMonitor.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/Objects/VirtualMonitor.vala"
		break;
#line 1641 "VirtualMonitor.c"
	}
}

static void
_vala_display_virtual_monitor_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec)
{
	DisplayVirtualMonitor * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DISPLAY_TYPE_VIRTUAL_MONITOR, DisplayVirtualMonitor);
#line 22 "../src/Objects/VirtualMonitor.vala"
	switch (property_id) {
#line 22 "../src/Objects/VirtualMonitor.vala"
		case DISPLAY_VIRTUAL_MONITOR_X_PROPERTY:
#line 22 "../src/Objects/VirtualMonitor.vala"
		display_virtual_monitor_set_x (self, g_value_get_int (value));
#line 22 "../src/Objects/VirtualMonitor.vala"
		break;
#line 22 "../src/Objects/VirtualMonitor.vala"
		case DISPLAY_VIRTUAL_MONITOR_Y_PROPERTY:
#line 22 "../src/Objects/VirtualMonitor.vala"
		display_virtual_monitor_set_y (self, g_value_get_int (value));
#line 22 "../src/Objects/VirtualMonitor.vala"
		break;
#line 22 "../src/Objects/VirtualMonitor.vala"
		case DISPLAY_VIRTUAL_MONITOR_CURRENT_X_PROPERTY:
#line 22 "../src/Objects/VirtualMonitor.vala"
		display_virtual_monitor_set_current_x (self, g_value_get_int (value));
#line 22 "../src/Objects/VirtualMonitor.vala"
		break;
#line 22 "../src/Objects/VirtualMonitor.vala"
		case DISPLAY_VIRTUAL_MONITOR_CURRENT_Y_PROPERTY:
#line 22 "../src/Objects/VirtualMonitor.vala"
		display_virtual_monitor_set_current_y (self, g_value_get_int (value));
#line 22 "../src/Objects/VirtualMonitor.vala"
		break;
#line 22 "../src/Objects/VirtualMonitor.vala"
		case DISPLAY_VIRTUAL_MONITOR_SCALE_PROPERTY:
#line 22 "../src/Objects/VirtualMonitor.vala"
		display_virtual_monitor_set_scale (self, g_value_get_double (value));
#line 22 "../src/Objects/VirtualMonitor.vala"
		break;
#line 22 "../src/Objects/VirtualMonitor.vala"
		case DISPLAY_VIRTUAL_MONITOR_TRANSFORM_PROPERTY:
#line 22 "../src/Objects/VirtualMonitor.vala"
		display_virtual_monitor_set_transform (self, g_value_get_enum (value));
#line 22 "../src/Objects/VirtualMonitor.vala"
		break;
#line 22 "../src/Objects/VirtualMonitor.vala"
		case DISPLAY_VIRTUAL_MONITOR_PRIMARY_PROPERTY:
#line 22 "../src/Objects/VirtualMonitor.vala"
		display_virtual_monitor_set_primary (self, g_value_get_boolean (value));
#line 22 "../src/Objects/VirtualMonitor.vala"
		break;
#line 22 "../src/Objects/VirtualMonitor.vala"
		case DISPLAY_VIRTUAL_MONITOR_MONITORS_PROPERTY:
#line 22 "../src/Objects/VirtualMonitor.vala"
		display_virtual_monitor_set_monitors (self, g_value_get_object (value));
#line 22 "../src/Objects/VirtualMonitor.vala"
		break;
#line 22 "../src/Objects/VirtualMonitor.vala"
		case DISPLAY_VIRTUAL_MONITOR_IS_ACTIVE_PROPERTY:
#line 22 "../src/Objects/VirtualMonitor.vala"
		display_virtual_monitor_set_is_active (self, g_value_get_boolean (value));
#line 22 "../src/Objects/VirtualMonitor.vala"
		break;
#line 1709 "VirtualMonitor.c"
		default:
#line 22 "../src/Objects/VirtualMonitor.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/Objects/VirtualMonitor.vala"
		break;
#line 1715 "VirtualMonitor.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

